//
//  TOPPERS/JSP Kernel
//      Toyohashi Open Platform for Embedded Real-Time Systems/
//      Just Standard Profile Kernel
// 
//  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
//                              Toyohashi Univ. of Technology, JAPAN
//  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
//                   Tomakomai National College of Technology, JAPAN
//
//  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
//  ˤäƸɽƤ GNU General Public License  Version 2 ˵
//  ҤƤ˸¤ꡤܥեȥܥեȥ
//  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
//  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
//  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
//      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
//      ˴ޤޤƤ뤳ȡ
//  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
//      ѤǤǺۤˤϡۤȼɥȡ
//      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
//      ̵ݾڵǺܤ뤳ȡ
//  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
//      ѤǤʤǺۤˤϡΤ줫ξ
//      ȡ
//    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
//        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
//    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
//        𤹤뤳ȡ
//  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
//      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
//
//  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
//  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
//  ޤơʤݾڤԤʤޤܥեȥѤˤľ
//  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
// 
//  @(#) $Id: tinet_staticapi.cpp,v 1.2.1.6 2006/01/29 04:45:36 abe Exp abe $
//

#include "base/parser.h"

#include "tinet_defs.h"

#include <iostream>

// ֤̾λ

using namespace std;

//
// include API
//

DECLARE_API (INCLUDE, "INCLUDE")
{
	Token		token;
	Directory*	node;
	Directory*	scope;

	last = NULL;
	p.getToken(token, Token::STRINGLITERAL);
	token.chopLiteral();

	if ((token[0] != '\"' || token[token.size() - 1] != '\"') &&
	    (token[0] != '<'  || token[token.size() - 1] != '>' ))
		ExceptionMessage("An include filename must be enclosed with \"...\" or <...>",
		                 "ե̾ \"...\"  <...> ηǤʤФʤޤ").throwException();

	node = container.openChild(OBJECT_TREE, INCLUDE_FILE, NULL);
	last = node;

	// ʣå롣
	scope = node->getFirstChild();
	while (scope != 0) {
		if (token.compare(scope->toString()) == 0) {
			cerr << p.getStreamLocation() << ' ' 
			     << (Message("Include file % was already specified (ignored).",
			                 "󥯥롼ɥե %s ʣꤵޤ (̵뤷ޤ)") << token.c_str()) << endl;
			return;
			}
		scope = scope->getNext();
		}

	node->addChild(new Directory(token));
	}

//
// TCP_CRE_REP -- TCP ո
//

DECLARE_API (TCP_CRE_REP, "TCP_CRE_REP")
{
	Token		token;
	Directory*	node;

	p.getToken(token);
	node = allocate(container[OBJECT_TREE], token, TCP_CREATE_REP);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",", "{", NULL);
	parseParameters(p, node, "repatr");
	p.getToken(",", "{", NULL);
	parseParameters(p, node, "myipaddr,myportno");
	p.getToken("}", "}", NULL);
	}

//
// TCP_CRE_CEP -- TCP ̿ü
//

DECLARE_API (TCP_CRE_CEP, "TCP_CRE_CEP")
{
	Token		token;
	Directory*	node;

	p.getToken(token);
	node = allocate(container[OBJECT_TREE], token, TCP_CREATE_CEP);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",", "{", NULL);
	parseParameters(p, node, "cepatr,sbuf,sbufsz,rbuf,rbufsz,callback");
	p.getToken("}");
	}

//
// UDP_CRE_CEP -- UDP ̿ü
//

DECLARE_API (UDP_CRE_CEP, "UDP_CRE_CEP")
{
	Token		token;
	Directory*	node;

	p.getToken(token);
	node = allocate(container[OBJECT_TREE], token, UDP_CREATE_CEP);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",", "{", NULL);
	parseParameters(p, node, "cepatr");
	p.getToken(",", "{", NULL);
	parseParameters(p, node, "myipaddr,myportno");
	p.getToken("}", ",", NULL);
	parseParameters(p, node, "callback");
	p.getToken("}", NULL);
	}

//
// TCP6_CRE_REP -- TCP/IPv6 ո
//

DECLARE_API (TCP6_CRE_REP, "TCP6_CRE_REP")
{
	Token		token;
	Directory*	node;

	p.getToken(token);
	node = allocate(container[OBJECT_TREE], token, TCP6_CREATE_REP);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",", "{", NULL);
	parseParameters(p, node, "repatr");
	p.getToken(",", "{", NULL);
	parseParameters(p, node, "myipaddr,myportno");
	p.getToken("}", "}", NULL);
	}

//
// TCP6_CRE_CEP -- TCP/IPv6 ̿ü
//

DECLARE_API (TCP6_CRE_CEP, "TCP6_CRE_CEP")
{
	Token		token;
	Directory*	node;

	p.getToken(token);
	node = allocate(container[OBJECT_TREE], token, TCP6_CREATE_CEP);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",", "{", NULL);
	parseParameters(p, node, "cepatr,sbuf,sbufsz,rbuf,rbufsz,callback");
	p.getToken("}");
	}

//
// UDP6_CRE_CEP -- UDP/IPv6 ̿ü
//

DECLARE_API (UDP6_CRE_CEP, "UDP6_CRE_CEP")
{
	Token		token;
	Directory*	node;

	p.getToken(token);
	node = allocate(container[OBJECT_TREE], token, UDP6_CREATE_CEP);
	(*node)["position"] = p.getStreamLocation();

	p.getToken(",", "{", NULL);
	parseParameters(p, node, "cepatr");
	p.getToken(",", "{", NULL);
	parseParameters(p, node, "myipaddr,myportno");
	p.getToken("}", ",", NULL);
	parseParameters(p, node, "callback");
	p.getToken("}", NULL);
	}
