/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: net.h,v 1.2.1.6 2006/01/29 04:43:01 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1989, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef _NET_H_
#define _NET_H_

/*
 *  ХȥѴ
 */

#if !defined(SIL_ENDIAN)

#error "SIL_ENDIAN expected."

#else	/* of #if !defined(SIL_ENDIAN) */

#if SIL_ENDIAN == SIL_ENDIAN_BIG

#define ntohs(n)		(n)
#define htons(h)		(h)
#define ntohl(n)		(n)
#define htonl(h)		(h)

#define NTOHS(n)
#define HTONS(h)
#define NTOHL(n)
#define HTONL(h)

/*
 *  : IPإåʹߤϡ4 Хȶ˥饤󤵤Ƥ
 *        ȤƤ뤬4 Хȶǥ
 *        ץåǡͥåȥ¦Υǡ4 Хȶ˥饤
 *        Ƥʤϡntoahlahtonlnahcmpl Ѥ뤳ȡ
 */

#define ntoahl(h,n)		memcpy((UB*)&(h),(n),4)
#define ahtonl(n,h)		memcpy((n),(UB*)&(h),4)

#define nahcmpl(n,h)		memcmp((n),(UB*)&(h),4)

#elif SIL_ENDIAN == SIL_ENDIAN_LITTLE

#ifndef NET_REV_ENDIAN_HWORD

#define NET_REV_ENDIAN_HWORD(d)	((UH)((((UH)(d)&0xff)<<8)|(((UH)(d)>>8)&0xff)))

#endif	/* of #ifndef NET_REV_ENDIAN_HWORD */

#ifndef NET_REV_ENDIAN_WORD

#define NET_REV_ENDIAN_WORD(d)	((UW)((((UW)(d)&0xff)<<24)|(((UW)(d)&0xff00)<<8)| \
				      (((UW)(d)>>8)&0xff00)|(((UW)(d)>>24)&0xff)))

#endif	/* of #ifndef NET_REV_ENDIAN_WORD */

#define ntohs(n)		NET_REV_ENDIAN_HWORD(n)
#define htons(h)		NET_REV_ENDIAN_HWORD(h)
#define ntohl(n)		NET_REV_ENDIAN_WORD(n)
#define htonl(h)		NET_REV_ENDIAN_WORD(h)

#define NTOHS(n)		((n)=NET_REV_ENDIAN_HWORD(n))
#define HTONS(h)		((h)=NET_REV_ENDIAN_HWORD(h))
#define NTOHL(n)		((n)=NET_REV_ENDIAN_WORD(n))
#define HTONL(h)		((h)=NET_REV_ENDIAN_WORD(h))

/*
 *  : IPإåʹߤϡ4 Хȶ˥饤󤵤Ƥ
 *        ȤƤ뤬4 Хȶǥ
 *        ץåǡͥåȥ¦Υǡ4 Хȶ˥饤
 *        Ƥʤϡntoahlahtonlnahcmpl Ѥ뤳ȡ
 */

extern void rev_memcpy_word (UB *dst, UB *src);
extern int  rev_memcmp_word (UB *data1, UB *data2);

#define ntoahl(h,n)		rev_memcpy_word((UB*)&(h),(n))
#define ahtonl(n,h)		rev_memcpy_word((n),(UB*)&(h))
#define nahcmpl(n,h)		rev_memcmp_word((n),(UB*)&(h))

#endif	/* #if SIL_ENDIAN == SIL_ENDIAN_BIG */

#endif	/* of #if !defined(SIL_ENDIAN) */

/*
 *  ץȥ̤ե饰˴ؤ
 *
 *    ǥХå
 *    ׾
 */

#define PROTO_FLG_PPP_HDLC	0x00000001	/* ppp_hdlc.c	*/
#define PROTO_FLG_PPP_FSM	0x00000002	/* ppp_fsm.c	*/
#define PROTO_FLG_PPP_AUTH	0x00000004	/* ppp_auth.c	*/
#define PROTO_FLG_PPP_LCP	0x00000008	/* ppp_lcp.c	*/
#define PROTO_FLG_PPP_IPCP	0x00000010	/* ppp_ipcp.c	*/
#define PROTO_FLG_PPP_CCP	0x00000020	/* ppp_ccp.c	*/
#define PROTO_FLG_PPP_PAP	0x00000040	/* ppp_upap.c	*/
#define PROTO_FLG_PPP_MODEM	0x00000080	/* ppp_modem.c	*/
#define PROTO_FLG_PPP		0x00000100	/* ppp.c	*/

#define PROTO_FLG_ETHER_NIC	0x00000001	/* if_??.c	*/

#define PROTO_FLG_LOOP		0x00000100	/* if_loop.c	*/

#define PROTO_FLG_ETHER		0x00000100	/* ethernet.c	*/

#define PROTO_FLG_IF		0x00000800	/* if.c		*/

#define PROTO_FLG_ARP		0x00008000	/* if_ether.c	*/

#define PROTO_FLG_IP4		0x00010000	/* ip_*.c	*/
#define PROTO_FLG_ICMP4		0x00040000	/* ip_icmp.c	*/

#define PROTO_FLG_IP6		0x00100000	/* ip6_*.c	*/
#define PROTO_FLG_ICMP6		0x00400000	/* icmp6.c	*/
#define PROTO_FLG_ND6		0x00800000	/* nd6_*.c	*/

#define PROTO_FLG_UDP		0x08000000	/* udp_*.c	*/

#define PROTO_FLG_TCP		0x01000000	/* tcp_*.c	*/

#define PROTO_FLG_NET_BUF	0x10000000	/* net_buf.c	*/
#define PROTO_FLG_NET		0x80000000	/* route.c, net*.c	*/

/*
 *  ɥ쥹
 */

#define AT_ETHER		0x01		/* ͥå		*/
#define AT_INET4		0x10		/* IPv4 ɥ쥹	*/
#define AT_INET6		0x20		/* IPv6 ɥ쥹	*/

#ifndef _MACRO_ONLY

/*
 *  TINET ȼؿ
 */

extern UB *mac2str (UB *buf, UB *macaddr);

#endif	/* of #ifndef _MACRO_ONLY */

#endif	/* of #ifndef _NET_H_ */
