/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: net_buf.c,v 1.2.1.6 2006/01/29 04:43:01 abe Exp abe $
 */

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_loop.h>
#include <net/if_ppp.h>
#include <net/ethernet.h>
#include <net/net.h>
#include <net/net_buf.h>
#include <net/net_count.h>

/*
 *  ѿ
 */

static T_NET_BUF_ENTRY net_buf_table[] = {

#if defined(SUPPORT_INET4) && defined(IP4_CFG_FRAGMENT)

	{ MPF_NET_BUF_4096,	4096		},

#endif	/* of #if defined(SUPPORT_INET4) && defined(IP4_CFG_FRAGMENT) */

	{ MPF_NET_BUF_IF_PDU,	IF_PDU_SIZE	},
	{ MPF_NET_BUF_1024,	1024		},
	{ MPF_NET_BUF_512,	512		},
	{ MPF_NET_BUF_256,	256		},
	{ MPF_NET_BUF_128,	128		},
	};

#if NET_COUNT_ENABLE & PROTO_FLG_NET_BUF

/*
 *  nbuf_get_tbl -- ͥåȥХåեɽ롣
 *
 *    : ͥåȥ׾η¬
 */

const T_NET_BUF_ENTRY *
nbuf_get_tbl (void)
{
	return net_buf_table;
	}

/*
 *  nbuf_get_tbl_size -- ͥåȥХåեȥ롣
 *
 *    : ͥåȥ׾η¬
 */

int
nbuf_get_tbl_size (void)
{
	return sizeof(net_buf_table) / sizeof(T_NET_BUF_ENTRY);
	}

#endif	/* of #if NET_COUNT_ENABLE & PROTO_FLG_NET_BUF */

/*
 *  tget_net_buf -- ͥåȥХåե롣
 */

/*#define ASSERT_FLG	PROTO_FLG_NET_BUF*/	/* ƥ顼ϤϥȤ򳰤*/


ER
tget_net_buf (T_NET_BUF **buf, UH len, TMO tmout)
{
	INT	ix, req_ix;
	ER	error;
	UH	size;

	if (len > MAX_NET_BUF_SIZE)	/* ΥĶƤ饨顼 */
		return E_PAR;

	size = MIN_NET_BUF_SIZE;	/* ŬʸĹסõ*/
	ix = sizeof(net_buf_table) / sizeof(T_NET_BUF_ENTRY);
	while (ix -- > 0 && len > net_buf_table[ix].size)
		;
	req_ix = ix;

	NET_COUNT_NET_BUF(net_buf_table[req_ix].requests, 1);

#if ASSERT_FLG & PROTO_FLG_NET_BUF

	while (1) {
		if ((error = tget_mpf(net_buf_table[ix].index, (VP*)buf, TMO_POL)) == E_OK) {
			(*buf)->idix = ix;
			(*buf)->len  = len;
			(*buf)->unit = 0;
			NET_COUNT_NET_BUF(net_buf_table[ix].allocs, 1);
			NET_COUNT_NET_BUF(net_buf_table[ix].busy, 1);
			return error;
			}
		else if (ix == 0)
			break;
		ix --;
		}

#else	/* of #if ASSERT_FLG & PROTO_FLG_NET_BUF */

	while (1) {
		if ((error = tget_mpf(net_buf_table[ix].index, (VP*)buf, ix == 0 ? tmout : TMO_POL)) == E_OK) {
			(*buf)->idix = ix;
			(*buf)->len  = len;
			(*buf)->unit = 0;
			NET_COUNT_NET_BUF(net_buf_table[ix].allocs, 1);
			NET_COUNT_NET_BUF(net_buf_table[ix].busy, 1);
			return error;
			}
		else if (ix == 0)
			break;
		ix --;
		}

#endif	/* of #if ASSERT_FLG & PROTO_FLG_NET_BUF */

	syslog(LOG_WARNING, "[NET BUF] busy, len=%d, index=%d", len, req_ix);

	*buf = NULL;

	NET_COUNT_NET_BUF(net_buf_table[req_ix].errors, 1);

	return error;
	}

/*
 * rel_net_buf -- ͥåȥХåեֵѤ롣
 */

ER
rel_net_buf (T_NET_BUF *buf)
{
	ER	error = E_OK;

	if (buf->idix >= sizeof(net_buf_table) / sizeof(T_NET_BUF_ENTRY)) {
		error = E_ID;
		}
	else {
		NET_COUNT_NET_BUF(net_buf_table[buf->idix].busy, -1);
		error = rel_mpf(net_buf_table[buf->idix].index, (VP)buf);
		}
	return error;
	}
