/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: dbg_cons.c,v 1.2.1.1 2004/10/13 05:59:09 abe Exp abe $
 */

/* 
 *  ǥХå󥽡
 */

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <stdlib.h>

#include "../kernel/jsp_kernel.h"
#include "../kernel/task.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/net.h>
#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/net_buf.h>
#include <net/net_timer.h>
#include <net/ppp_var.h>
#include <net/ppp_fsm.h>
#include <net/ppp_lcp.h>
#include <net/ppp_ipcp.h>
#include <net/ppp_modem.h>
#include <net/net_count.h>

#include <netinet/in.h>
#include <netinet/in_var.h>
#include <netinet/in_itron.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/if_ether.h>
#include <netinet/tcp.h>
#include <netinet/tcp_timer.h>
#include <netinet/tcp_var.h>
#include <netinet/tcp_fsm.h>
#include <netinet/ip6.h>
#include <netinet6/ip6_var.h>
#include <netinet6/nd6.h>

#include <net/if_var.h>
#include <net/if6_var.h>

#include <netapp/netapp.h>
#include <netapp/netapp_var.h>
#include <netapp/echo.h>
#include <netapp/discard.h>
#include <netapp/dbg_cons.h>

#define DBG_LINE_SIZE	63

/*
 *  task_status -- ξ֤ν
 */

static const char task_stat_str[][sizeof("SUSPENDED")] = {
	"DORMANT",		/* ٻ߾		*/
	"RUNNABLE",		/* ¹ԤǤ	*/
	"WAINTING",		/* Ԥ		*/
	"SUSPENDED",		/* Ԥ		*/

	"SLEEP",		/* Ԥ				*/
	"WOBJ",			/* Ʊ֥̿ȤФԤ	*/
	"WOBJCB",		/* ʬԤ塼ˤĤʤäƤ롣	*/
	};

static void
task_status (UB *line)
{
	TCB	*tcb;
	int	ix, st, sx;

	cons_printf(CONSOLE_PORTID,
	             "TASK Status\n"
	             "ID PI State\n");
	for (ix = TMIN_TSKID; ix <= tmax_tskid; ix ++) {
		tcb = get_tcb(ix);
		cons_printf(CONSOLE_PORTID, "%2d %2d ", ix, tcb->priority);
		st = tcb->tstat;
		for (sx = 0; st; sx ++) {
			if (st & 0x01) {
				cons_printf(CONSOLE_PORTID, "%s", task_stat_str[sx]);
				if (st & 0xfe)
					cons_printf(CONSOLE_PORTID, "|");
				}
			st >>= 1;
			}
		cons_printf(CONSOLE_PORTID, "\n");
		}
	}

/*
 *  tcp_status -- TCP ξ֤ν
 */

static const char tcp_fsm_str[][sizeof("ESTABLISHED")] = {
	"CLOSED",		/* 			*/
	"LISTEN",		/* ưץ			*/
	"SYN_SENT",		/* ǽưץSYN Ѥ	*/
	"SYN_RECVD",		/* ưץSYN Ѥ	*/
	"ESTABLISHED",		/* ͥߴλ		*/
	"CLOSE_WAIT",		/* ꤫ FIN APP νλԤ	*/
	"FIN_WAIT_1",		/* APP λFIN ѤߡACK Ԥ	*/
	"CLOSING",		/* ƱFIN 򴹺ѤߡACK Ԥ	*/
	"LAST_ACK",		/* APP λACK Ԥ			*/
	"FIN_WAIT_2",		/* ꤫ FIN Ԥ			*/
	"TIME_WAIT",		/* ꤫ FIN ѤߡԤ	*/
	};

#ifdef SUPPORT_INET4

static void
tcp_status (UB *line)
{
	T_TCP_CCEP*	cep;
	T_TCP_CREP*	rep;
	int		len, cnt;

	cons_printf(CONSOLE_PORTID,
	             "TCP CEP Status\n"
	             "ID Snd-Q Rcv-Q Local Address         Foreign Address       State\n");

	for (cep = tcp_ccep; cep < &tcp_ccep[tmax_tcp_ccepid]; cep ++)
		if (cep->fsm_state == TCP_FSM_CLOSED) {
			cons_printf(CONSOLE_PORTID,
			             "%2d     0     0"
			             " -                    "
			             " -                    "
			             " CLOSED\n",
			             GET_TCP_CCEPID(cep));
			}
		else if (cep->fsm_state == TCP_FSM_LISTEN) {
			cons_printf(CONSOLE_PORTID, "%2d     0     0 ", GET_TCP_CCEPID(cep));
			len  = PUT_IPADDR(CONSOLE_PORTID, &cep->myaddr.ipaddr, 0);
			cons_putchar(CONSOLE_PORTID, ':');
			len += cons_putnumber(CONSOLE_PORTID, cep->myaddr.portno, 10, radhex, 0, FALSE, ' ');
			for (len = 20 - len; len -- > 0; )
				cons_putchar(CONSOLE_PORTID, ' ');
			cons_printf(CONSOLE_PORTID,
			             " -                    "
			             " LISTEN\n");
			}
		else {
			cons_printf(CONSOLE_PORTID, "%2d %5d %5d ",
			             GET_TCP_CCEPID(cep), cep->sbuf_count, cep->rbuf_count);
			len  = PUT_IPADDR(CONSOLE_PORTID, &cep->myaddr.ipaddr, 0);
			cons_putchar(CONSOLE_PORTID, ':');
			len += cons_putnumber(CONSOLE_PORTID, cep->myaddr.portno, 10, radhex, 0, FALSE, ' ');
			for (len = 21 - len; len -- > 0; )
				cons_putchar(CONSOLE_PORTID, ' ');
			len  = PUT_IPADDR(CONSOLE_PORTID, &cep->dstaddr.ipaddr, 0);
			cons_putchar(CONSOLE_PORTID, ':');
			len += cons_putnumber(CONSOLE_PORTID, cep->dstaddr.portno, 10, radhex, 0, FALSE, ' ');
			for (len = 20 - len; len -- > 0; )
				cons_putchar(CONSOLE_PORTID, ' ');
			if (cep->fsm_state == TCP_FSM_TIME_WAIT)
				cons_printf(CONSOLE_PORTID, " %s(%d)\n", tcp_fsm_str[cep->fsm_state],
				                             cep->timer[TCP_TIM_2MSL] / TCP_SLOW_HZ);
			else
				cons_printf(CONSOLE_PORTID, " %s\n", tcp_fsm_str[cep->fsm_state]);
			}

	cons_printf(CONSOLE_PORTID,
	             "TCP REP Status\n"
	             "ID Local Address         CEP\n");
	for (rep = tcp_crep; rep < &tcp_crep[tmax_tcp_crepid]; rep ++) {
		cons_printf(CONSOLE_PORTID, "%2d ", GET_TCP_CREPID(rep));
		len  = PUT_IPADDR(CONSOLE_PORTID, &rep->myaddr.ipaddr, 0);
		cons_putchar(CONSOLE_PORTID, ':');
		len += cons_putnumber(CONSOLE_PORTID, rep->myaddr.portno, 10, radhex, 0, FALSE, ' ');
		for (len = 21 - len; len -- > 0; )
			cons_putchar(CONSOLE_PORTID, ' ');
		cnt = 0;
		for (cep = tcp_ccep; cep < &tcp_ccep[tmax_tcp_ccepid]; cep ++) {
			if (cep->rep == rep) {
				if (cnt > 0)
					cons_printf(CONSOLE_PORTID, ",%d", GET_TCP_CCEPID(cep));
				else
					cons_printf(CONSOLE_PORTID, "%d", GET_TCP_CCEPID(cep));
				cnt ++;
				}
			}
		cons_putchar(CONSOLE_PORTID, '\n');
		}
	}

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

static void
tcp_status (UB *line)
{
	T_TCP_CCEP*	cep;
	T_TCP_CREP*	rep;
	int		len, cnt;

	cons_printf(CONSOLE_PORTID,
	             "TCP CEP Status\n"
	             "ID Snd-Q Rcv-Q Foreign Address                             State\n");

	for (cep = tcp_ccep; cep < &tcp_ccep[tmax_tcp_ccepid]; cep ++)
		if (cep->fsm_state == TCP_FSM_CLOSED) {
			cons_printf(CONSOLE_PORTID,
			             "%2d     0     0"
			             " -                                          "
			             " CLOSED\n",
			             GET_TCP_CCEPID(cep));
			}
		else if (cep->fsm_state == TCP_FSM_LISTEN) {
			cons_printf(CONSOLE_PORTID, "%2d     0     0", GET_TCP_CCEPID(cep));
			cons_printf(CONSOLE_PORTID,
			             " -                                          "
			             " LISTEN\n");
			}
		else {
			cons_printf(CONSOLE_PORTID, "%2d %5d %5d ",
			             GET_TCP_CCEPID(cep), cep->sbuf_count, cep->rbuf_count);
			len  = PUT_IPADDR(CONSOLE_PORTID, &cep->dstaddr.ipaddr, 0);
			cons_putchar(CONSOLE_PORTID, '.');
			len += cons_putnumber(CONSOLE_PORTID, cep->dstaddr.portno, 10, radhex, 0, FALSE, ' ');
			for (len = 42 - len; len -- > 0; )
				cons_putchar(CONSOLE_PORTID, ' ');
			if (cep->fsm_state == TCP_FSM_TIME_WAIT)
				cons_printf(CONSOLE_PORTID, " %s(%d)\n", tcp_fsm_str[cep->fsm_state],
				                             cep->timer[TCP_TIM_2MSL] / TCP_SLOW_HZ);
			else
				cons_printf(CONSOLE_PORTID, " %s\n", tcp_fsm_str[cep->fsm_state]);
			}

	cons_printf(CONSOLE_PORTID,
	             "TCP REP Status\n"
	             "ID Local Address         CEP\n");
	for (rep = tcp_crep; rep < &tcp_crep[tmax_tcp_crepid]; rep ++) {
		cons_printf(CONSOLE_PORTID, "%2d ", GET_TCP_CREPID(rep));
		len  = PUT_IPADDR(CONSOLE_PORTID, &rep->myaddr.ipaddr, 0);
		cons_putchar(CONSOLE_PORTID, '.');
		len += cons_putnumber(CONSOLE_PORTID, rep->myaddr.portno, 10, radhex, 0, FALSE, ' ');
		for (len = 21 - len; len -- > 0; )
			cons_putchar(CONSOLE_PORTID, ' ');
		cnt = 0;
		for (cep = tcp_ccep; cep < &tcp_ccep[tmax_tcp_ccepid]; cep ++) {
			if (cep->rep == rep) {
				if (cnt > 0)
					cons_printf(CONSOLE_PORTID, ",%d", GET_TCP_CCEPID(cep));
				else
					cons_printf(CONSOLE_PORTID, "%d", GET_TCP_CCEPID(cep));
				cnt ++;
				}
			}
		cons_putchar(CONSOLE_PORTID, '\n');
		}
	}

#endif	/* of #ifdef SUPPORT_INET6 */

#ifdef SUPPORT_ETHER

#ifdef SUPPORT_INET4

/*
 *  ifa_status -- ARP å
 */

static void
ifa_status (UB *line)
{
	const T_ARP_ENTRY	*cache;
	int			ix;

	cons_printf(CONSOLE_PORTID,
	             "ARP Cache\n"
	             "IX Expire IP Address      MAC Address\n");

	/* expire ñ̤ [ms]*/
	cache = arp_get_cache();
	for (ix = 0; ix < NUM_ARP_ENTRY; ix ++) {
		if (cache[ix].expire != 0)
			cons_printf(CONSOLE_PORTID, "%2d %6d %15I %M\n",
			            ix, cache[ix].expire / NET_TIMER_HZ,
			                &cache[ix].ip_addr, cache[ix].mac_addr);
		}
	}

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

/*
 * ifa_status -- ٥å֤ν
 */

static const char nd_state_str[][sizeof("INCOMPLETE")] = {
	"FREE",			/* ̤		*/
	"NO STATE",		/* ̤		*/
	"INCOMPLETE",		/* ̤		*/
	"REACHABLE",		/* ãǽ		*/
	"STALE",		/* ãǽ̤ǧ	*/
	"DELAY",		/* ãǽγǧԵ	*/
	"PROBE",		/* ãǽǧ	*/
	};

static void
ifa_status (UB *line)
{
	const T_LLINFO_ND6	*cache;
	SYSTIM			now;
	int			ix;

	cons_printf(CONSOLE_PORTID,
	             "ND Cache Status\n"
	             "IX Expire State      IP Address\n");

	/* expire ñ̤ [ms]*/
	syscall(get_tim(&now));
	cache = nd6_get_cache();
	for (ix = 0; ix < NUM_ND6_CACHE_ENTRY; ix ++) {
		if (cache[ix].state != ND6_LLINFO_FREE) {
			cons_printf(CONSOLE_PORTID, "%2d %6d %10s %I\n",
			            ix, 
			            cache[ix].state == ND6_LLINFO_STALE ? 0 : (cache[ix].expire - now) / SYSTIM_HZ,
			            nd_state_str[cache[ix].state],
			            &cache[ix].addr);
			}
		}
	}

#endif	/* of #ifdef SUPPORT_INET6 */

#endif	/* of #ifdef SUPPORT_ETHER */

/*
 *  net_count_struct -- ͥåȥ׾
 */

static void
net_count_struct (char *name, T_NET_COUNT *item)
{
	cons_printf(CONSOLE_PORTID, "\n%s\n", name);
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n", item->in_octets);
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n", item->out_octets);
	cons_printf(CONSOLE_PORTID, "\tХåȿ\t%lu\n", item->in_packets);
	cons_printf(CONSOLE_PORTID, "\tХåȿ\t%lu\n", item->out_packets);
	cons_printf(CONSOLE_PORTID, "\t顼Хåȿ\t%lu\n", item->in_err_packets);
	cons_printf(CONSOLE_PORTID, "\t顼Хåȿ\t%lu\n", item->out_err_packets);
	}

/*
 *  net_count -- ͥåȥ׾
 */

static void
net_count (UB *line)
{
	const T_NET_BUF_ENTRY	*tbl;
	SYSTIM		now;
	int		ix;

	syscall(get_tim(&now));
	cons_printf(CONSOLE_PORTID, "ͥåȥ׾\tв[ms]\t%lu\t", now);
	if (now > (1000 * 3600 * 24))
		cons_printf(CONSOLE_PORTID, "%3lu %2lu %2luʬ %2lu\n",
		             now / (1000 * 3600 * 24),
		            (now / (1000 * 3600)) % 24,
		            (now / (1000 * 60  )) % 60,
		            (now /  1000        ) % 60);
	else
		cons_printf(CONSOLE_PORTID, "%2lu %2luʬ %2lu\n",
		            (now / (1000 * 3600)) % 24,
		            (now / (1000 * 60  )) % 60,
		            (now /  1000        ) % 60);

#ifdef SUPPORT_PPP

	net_count_struct("HDLC", &net_count_hdlc);
	cons_printf(CONSOLE_PORTID, "\nPPP\n");
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n",	net_count_ppp.in_octets);
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n",	net_count_ppp.out_octets);
	cons_printf(CONSOLE_PORTID, "\tХåȿ\t%lu\n",		net_count_ppp.in_packets);
	cons_printf(CONSOLE_PORTID, "\tХåȿ\t%lu\n",		net_count_ppp.out_packets);
	cons_printf(CONSOLE_PORTID, "\t顼Хåȿ\t%lu\n",	net_count_ppp.in_err_packets);
	cons_printf(CONSOLE_PORTID, "\t顼Хåȿ\t%lu\n",	net_count_ppp.out_err_packets);
	cons_printf(CONSOLE_PORTID, "\tnet_buf ƼԿ\t%lu\n",	net_count_ppp_no_bufs);

	cons_printf(CONSOLE_PORTID, "\nLCP\n");
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n",	net_count_ppp_lcp_in_octets);
	cons_printf(CONSOLE_PORTID, "\tХåȿ\t%lu\n",		net_count_ppp_lcp_in_packets);

	cons_printf(CONSOLE_PORTID, "\nIPCP\n");
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n",	net_count_ppp_ipcp_in_octets);
	cons_printf(CONSOLE_PORTID, "\tХåȿ\t%lu\n",		net_count_ppp_ipcp_in_packets);

	cons_printf(CONSOLE_PORTID, "\nPAP\n");
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n",	net_count_ppp_upap_in_octets);
	cons_printf(CONSOLE_PORTID, "\tХåȿ\t%lu\n",		net_count_ppp_upap_in_packets);

#endif	/* of #ifdef SUPPORT_PPP */

#ifdef SUPPORT_ETHER

	net_count_struct("ͥå", &net_count_ether);

	cons_printf(CONSOLE_PORTID, "\nͥåȡͥåȥ󥿥ե\n");
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n",			net_count_ether_nic[NC_ETHER_NIC_IN_OCTETS]);
	cons_printf(CONSOLE_PORTID, "\tХåȿ\t%lu\n",			net_count_ether_nic[NC_ETHER_NIC_IN_PACKETS]);
	cons_printf(CONSOLE_PORTID, "\t顼Хåȿ\t%lu\n",		net_count_ether_nic[NC_ETHER_NIC_IN_ERR_PACKETS]);
	cons_printf(CONSOLE_PORTID, "\tnet_buf ƼԿ\t%lu\n",		net_count_ether_nic[NC_ETHER_NIC_NO_BUFS]);
	cons_printf(CONSOLE_PORTID, "\tޥեֵѾ¥С\t%lu\n",	net_count_ether_nic[NC_ETHER_NIC_RXB_QOVRS]);
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n",			net_count_ether_nic[NC_ETHER_NIC_OUT_OCTETS]);
	cons_printf(CONSOLE_PORTID, "\tХåȿ\t%lu\n",			net_count_ether_nic[NC_ETHER_NIC_OUT_PACKETS]);
	cons_printf(CONSOLE_PORTID, "\t顼Хåȿ\t%lu\n",		net_count_ether_nic[NC_ETHER_NIC_OUT_ERR_PACKETS]);
	cons_printf(CONSOLE_PORTID, "\tꥸ\t%lu\n",			net_count_ether_nic[NC_ETHER_NIC_COLS]);
	cons_printf(CONSOLE_PORTID, "\tޥեֵѾ¥С\t%lu\n",	net_count_ether_nic[NC_ETHER_NIC_TXB_QOVRS]);
	cons_printf(CONSOLE_PORTID, "\tॢȿ	\t%lu\n",		net_count_ether_nic[NC_ETHER_NIC_TIMEOUTS]);
	cons_printf(CONSOLE_PORTID, "\tꥻåȿ\t%lu\n",			net_count_ether_nic[NC_ETHER_NIC_RESETS]);

#endif	/* of #ifdef SUPPORT_ETHER */

#ifdef SUPPORT_INET4

#ifdef SUPPORT_ETHER

	net_count_struct("ARP", &net_count_arp);

#endif	/* of #ifdef SUPPORT_ETHER */

	cons_printf(CONSOLE_PORTID, "\nIPv4\n");
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n",			net_count_ip4[NC_IP4_IN_OCTETS]);
	cons_printf(CONSOLE_PORTID, "\tǡ\t%lu\n",		net_count_ip4[NC_IP4_IN_PACKETS]);
	cons_printf(CONSOLE_PORTID, "\t顼ǡ\t%lu\n",		net_count_ip4[NC_IP4_IN_ERR_PACKETS]);
	cons_printf(CONSOLE_PORTID, "\tå२顼\t%lu\n",		net_count_ip4[NC_IP4_IN_ERR_CKSUM]);
	cons_printf(CONSOLE_PORTID, "\tĹ顼\t%lu\n",			net_count_ip4[NC_IP4_IN_ERR_SHORT]);
	cons_printf(CONSOLE_PORTID, "\tС󥨥顼\t%lu\n",		net_count_ip4[NC_IP4_IN_ERR_VER]);
	cons_printf(CONSOLE_PORTID, "\tɥ쥹顼\t%lu\n",			net_count_ip4[NC_IP4_IN_ERR_ADDR]);
	cons_printf(CONSOLE_PORTID, "\tץȥ륨顼\t%lu\n",		net_count_ip4[NC_IP4_IN_ERR_PROTO]);
	cons_printf(CONSOLE_PORTID, "\tץϿ\t%lu\n",			net_count_ip4[NC_IP4_OPTS]);
	cons_printf(CONSOLE_PORTID, "\tʬ\t%lu\n",			net_count_ip4[NC_IP4_FRAG_IN]);
	cons_printf(CONSOLE_PORTID, "\tʬե饰ȿ\t%lu\n",		net_count_ip4[NC_IP4_FRAG_IN_FRAGS]);
	cons_printf(CONSOLE_PORTID, "\tʬƹ\t%lu\n",		net_count_ip4[NC_IP4_FRAG_IN_OK]);
	cons_printf(CONSOLE_PORTID, "\tʬ˴\t%lu\n",			net_count_ip4[NC_IP4_FRAG_IN_DROP]);
	cons_printf(CONSOLE_PORTID, "\tʬХåեƼԿ\t%lu\n",	net_count_ip4[NC_IP4_FRAG_IN_NO_BUF]);
	cons_printf(CONSOLE_PORTID, "\tʬॢȿ\t%lu\n",		net_count_ip4[NC_IP4_FRAG_IN_TMOUT]);
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n",			net_count_ip4[NC_IP4_OUT_OCTETS]);
	cons_printf(CONSOLE_PORTID, "\tǡ\t%lu\n",		net_count_ip4[NC_IP4_OUT_PACKETS]);
	cons_printf(CONSOLE_PORTID, "\t顼ǡ\t%lu\n",		net_count_ip4[NC_IP4_OUT_ERR_PACKETS]);
	cons_printf(CONSOLE_PORTID, "\tʬ\t%lu\n",			net_count_ip4[NC_IP4_FRAG_OUT]);
	cons_printf(CONSOLE_PORTID, "\tʬե饰ȿ\t%lu\n",		net_count_ip4[NC_IP4_FRAG_OUT_FRAGS]);

	net_count_struct("ICMP", &net_count_icmp4);

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

	cons_printf(CONSOLE_PORTID, "\nIPv6\n");
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n",			net_count_ip6[NC_IP6_IN_OCTETS]);
	cons_printf(CONSOLE_PORTID, "\tǡ\t%lu\n",		net_count_ip6[NC_IP6_IN_PACKETS]);
	cons_printf(CONSOLE_PORTID, "\t顼ǡ\t%lu\n",		net_count_ip6[NC_IP6_IN_ERR_PACKETS]);
	cons_printf(CONSOLE_PORTID, "\tĹ顼\t%lu\n",			net_count_ip6[NC_IP6_IN_ERR_SHORT]);
	cons_printf(CONSOLE_PORTID, "\tС󥨥顼\t%lu\n",		net_count_ip6[NC_IP6_IN_ERR_VER]);
	cons_printf(CONSOLE_PORTID, "\tɥ쥹顼\t%lu\n",			net_count_ip6[NC_IP6_IN_ERR_ADDR]);
	cons_printf(CONSOLE_PORTID, "\tץȥ륨顼\t%lu\n",		net_count_ip6[NC_IP6_IN_ERR_PROTO]);
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n",			net_count_ip6[NC_IP6_OUT_OCTETS]);
	cons_printf(CONSOLE_PORTID, "\tǡ\t%lu\n",		net_count_ip6[NC_IP6_OUT_PACKETS]);
	cons_printf(CONSOLE_PORTID, "\t顼ǡ\t%lu\n",		net_count_ip6[NC_IP6_OUT_ERR_PACKETS]);

	cons_printf(CONSOLE_PORTID, "\nICMPv6\n");
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n",			net_count_icmp6[NC_ICMP6_IN_OCTETS]);
	cons_printf(CONSOLE_PORTID, "\tѥåȿ\t%lu\n",			net_count_icmp6[NC_ICMP6_IN_PACKETS]);
	cons_printf(CONSOLE_PORTID, "\t顼ѥåȿ\t%lu\n",		net_count_icmp6[NC_ICMP6_IN_ERR_PACKETS]);
	cons_printf(CONSOLE_PORTID, "\tå२顼\t%lu\n",		net_count_icmp6[NC_ICMP6_IN_ERR_CKSUM]);
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n",			net_count_icmp6[NC_ICMP6_OUT_OCTETS]);
	cons_printf(CONSOLE_PORTID, "\tѥåȿ\t%lu\n",			net_count_icmp6[NC_ICMP6_OUT_PACKETS]);
	cons_printf(CONSOLE_PORTID, "\t顼ѥåȿ\t%lu\n",		net_count_icmp6[NC_ICMP6_OUT_ERR_PACKETS]);

	cons_printf(CONSOLE_PORTID, "\nõ\n");
	cons_printf(CONSOLE_PORTID, "\t롼μ\t%lu\n",		net_count_nd6[NC_ND6_RA_IN_PACKETS]);
	cons_printf(CONSOLE_PORTID, "\t롼\t%lu\n",		net_count_nd6[NC_ND6_RS_OUT_PACKETS]);
	cons_printf(CONSOLE_PORTID, "\tμ\t%lu\n",			net_count_nd6[NC_ND6_NA_IN_PACKETS]);
	cons_printf(CONSOLE_PORTID, "\t\t%lu\n",			net_count_nd6[NC_ND6_NA_OUT_PACKETS]);
	cons_printf(CONSOLE_PORTID, "\t\t%lu\n",			net_count_nd6[NC_ND6_NS_IN_PACKETS]);
	cons_printf(CONSOLE_PORTID, "\t\t%lu\n",			net_count_nd6[NC_ND6_NS_OUT_PACKETS]);
	cons_printf(CONSOLE_PORTID, "\tʣɥ쥹\t%lu\n",		net_count_nd6[NC_ND6_DAD_OUT_PACKETS]);

#endif	/* of #ifdef SUPPORT_INET6 */

#ifdef SUPPORT_TCP

	cons_printf(CONSOLE_PORTID, "\nTCP\n");
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n",		net_count_tcp[NC_TCP_RECV_OCTETS]);
	cons_printf(CONSOLE_PORTID, "\tǡƥåȿ\t%lu\n",	net_count_tcp[NC_TCP_RECV_DATA_OCTETS]);
	cons_printf(CONSOLE_PORTID, "\tȿ\t%lu\n",		net_count_tcp[NC_TCP_RECV_SEGS]);
	cons_printf(CONSOLE_PORTID, "\tǡȿ\t%lu\n",	net_count_tcp[NC_TCP_RECV_DATA_SEGS]);
	cons_printf(CONSOLE_PORTID, "\t۵ޥȿ\t%lu\n",	net_count_tcp[NC_TCP_RECV_URG_SEGS]);
	cons_printf(CONSOLE_PORTID, "\tإå\t%lu\n",	net_count_tcp[NC_TCP_RECV_BAD_HEADERS]);
	cons_printf(CONSOLE_PORTID, "\tå\t%lu\n",	net_count_tcp[NC_TCP_RECV_BAD_CKSUMS]);
	cons_printf(CONSOLE_PORTID, "\tACK \t%lu\n",		net_count_tcp[NC_TCP_RECV_ACKS]);
	cons_printf(CONSOLE_PORTID, "\t¿ ACK \t%lu\n",	net_count_tcp[NC_TCP_RECV_DUP_ACKS]);
	cons_printf(CONSOLE_PORTID, "\tRST \t%lu\n",		net_count_tcp[NC_TCP_RECV_RSTS]);
	cons_printf(CONSOLE_PORTID, "\t¿ſ\t%lu\n",		net_count_tcp[NC_TCP_RECV_DUP_SEGS]);
	cons_printf(CONSOLE_PORTID, "\t˴\t%lu\n",		net_count_tcp[NC_TCP_RECV_DROP_SEGS]);
	cons_printf(CONSOLE_PORTID, "\t塼\t%lu\n",		net_count_tcp[NC_TCP_FREE_RCV_QUEUE]);
	cons_printf(CONSOLE_PORTID, "\tǡƥåȿ\t%lu\n",	net_count_tcp[NC_TCP_SEND_DATA_OCTETS]);
	cons_printf(CONSOLE_PORTID, "\t楻ȿ\t%lu\n",	net_count_tcp[NC_TCP_SEND_CNTL_SEGS]);
	cons_printf(CONSOLE_PORTID, "\tȿ\t%lu\n",		net_count_tcp[NC_TCP_SEND_SEGS]);
	cons_printf(CONSOLE_PORTID, "\tȿ\t%lu\n",	net_count_tcp[NC_TCP_SEND_REXMIT_SEGS]);
	cons_printf(CONSOLE_PORTID, "\tǡȿ\t%lu\n",	net_count_tcp[NC_TCP_SEND_DATA_SEGS]);
	cons_printf(CONSOLE_PORTID, "\t۵ޥȿ\t%lu\n",	net_count_tcp[NC_TCP_SEND_URG_SEGS]);
	cons_printf(CONSOLE_PORTID, "\tACK \t%lu\n",		net_count_tcp[NC_TCP_SEND_ACKS]);
	cons_printf(CONSOLE_PORTID, "\tRST \t%lu\n",		net_count_tcp[NC_TCP_SEND_RSTS]);
	cons_printf(CONSOLE_PORTID, "\tRTT \t%lu\n",		net_count_tcp[NC_TCP_RTT_UPDATES]);
	cons_printf(CONSOLE_PORTID, "\tưץ\t%lu\n",		net_count_tcp[NC_TCP_ACCEPTS]);
	cons_printf(CONSOLE_PORTID, "\tǽưץ\t%lu\n",		net_count_tcp[NC_TCP_CONNECTS]);

#endif	/* of #ifdef SUPPORT_TCP */

#ifdef SUPPORT_UDP

	net_count_struct("UDP",  &net_count_udp);

#endif	/* of #ifdef SUPPORT_UDP */

	tbl = nbuf_get_tbl();
	cons_printf(CONSOLE_PORTID, "\nͥåȥХåե\n\t\t׵\t\tƥ顼\t\n");
	for (ix = nbuf_get_tbl_size(); ix -- > 0; ) {
		cons_printf(CONSOLE_PORTID, "\t%lu\t%lu\t%lu\t%lu\t%lu\n",
		                            tbl[ix].size,
		                            tbl[ix].requests,
		                            tbl[ix].allocs,
		                            tbl[ix].errors,
		                            tbl[ix].busy);
		}

	cons_printf(CONSOLE_PORTID, "\nͥåȥ׾\tв[ms]\t%lu\t", now);
	if (now > (1000 * 3600 * 24))
		cons_printf(CONSOLE_PORTID, "%3lu %2lu %2luʬ %2lu\n",
		             now / (1000 * 3600 * 24),
		            (now / (1000 * 3600)) % 24,
		            (now / (1000 * 60  )) % 60,
		            (now /  1000        ) % 60);
	else
		cons_printf(CONSOLE_PORTID, "%2lu %2luʬ %2lu\n",
		            (now / (1000 * 3600)) % 24,
		            (now / (1000 * 60  )) % 60,
		            (now /  1000        ) % 60);
	}

#ifdef SUPPORT_INET4

#ifdef IP4_CFG_FRAGMENT

extern T_NET_BUF *frag_queue[];

/*
 *  nbuf_stat_ip4_frag_queue -- IPv4 ƹ塼ͥåȥХåե
 */

static void
nbuf_stat_ip4_frag_queue (void)
{
	const T_NET_BUF_ENTRY	*tbl;
	T_NET_BUF		*nbuf;
	int			ix, fix, count;

	cons_printf(CONSOLE_PORTID, "\nIPƹ塼\nIndex\tTime");
	tbl = nbuf_get_tbl();
	for (ix = nbuf_get_tbl_size(); ix -- > 0; )
		cons_printf(CONSOLE_PORTID, "\t%d",tbl[ix].size);
	cons_printf(CONSOLE_PORTID, "\n");

	for (fix = 0; fix < NUM_IP4_FRAG_QUEUE; fix ++) {
		if (frag_queue[fix] != NULL) {
			cons_printf(CONSOLE_PORTID, "%d\t%d", fix, GET_QIP4_HDR(frag_queue[fix])->ttl);
			for (ix = nbuf_get_tbl_size(); ix -- > 0; ) {
				count = 0;
				for (nbuf = frag_queue[fix]; nbuf != NULL; nbuf = GET_QIP4_HDR(nbuf)->next)
					if (nbuf->idix == ix)
						count ++;
				cons_printf(CONSOLE_PORTID, "\t%d", count);
				}
			cons_printf(CONSOLE_PORTID, "\n");
			}
		}
	}

#endif	/* of #ifdef IP4_CFG_FRAGMENT */

#endif	/* of #ifdef SUPPORT_INET4 */

/*
 *  nbuf_status -- ͥåȥХåե
 */

static void
nbuf_status (UB *line)
{
	const T_NET_BUF_ENTRY	*tbl;
	T_NET_BUF	*nbuf;
	T_TCP_CCEP*	cep;
	SYSTIM		now;
	int		ix, count;

	syscall(get_tim(&now));
	cons_printf(CONSOLE_PORTID, "ͥåȥХåե\tв[ms]\t%lu\n", now);

	cons_printf(CONSOLE_PORTID, "\nͥåȥХåե\n\t\t׵\t\tƥ顼\t\n");
	tbl = nbuf_get_tbl();
	for (ix = nbuf_get_tbl_size(); ix -- > 0; ) {
		cons_printf(CONSOLE_PORTID, "\t%lu\t%lu\t%lu\t%lu\t%lu\n",
		                            tbl[ix].size,
		                            tbl[ix].requests,
		                            tbl[ix].allocs,
		                            tbl[ix].errors,
		                            tbl[ix].busy);
		}

	cons_printf(CONSOLE_PORTID, "\nCCEP\nCEPID");
	for (ix = nbuf_get_tbl_size(); ix -- > 0; )
		cons_printf(CONSOLE_PORTID, "\t%d",tbl[ix].size);
	cons_printf(CONSOLE_PORTID, "\n");

	for (cep = tcp_ccep; cep < &tcp_ccep[tmax_tcp_ccepid]; cep ++) {
		cons_printf(CONSOLE_PORTID, "%d", GET_TCP_CCEPID(cep));
		for (ix = nbuf_get_tbl_size(); ix -- > 0; ) {
			count = 0;
			for (nbuf = cep->segq; nbuf != NULL; nbuf = GET_TCP_Q_HDR(nbuf)->next)
				if (nbuf->idix == ix)
					count ++;
			cons_printf(CONSOLE_PORTID, "\t%d", count);
			}
		cons_printf(CONSOLE_PORTID, "\n");
		}

#ifdef SUPPORT_INET4

#ifdef IP4_CFG_FRAGMENT

	nbuf_stat_ip4_frag_queue();

#endif	/* of #ifdef IP4_CFG_FRAGMENT */

#endif	/* of #ifdef SUPPORT_INET4 */
	}

#ifdef SUPPORT_INET4

#if NUM_ROUTE_ENTRY > 0

/*
 *  routing_table_status -- ϩɽν
 */

static void
routing_table_status (UB *line)
{
	int	ix;

	if ('0' <= *(line = skip_blanks(line)) && *line <= '9') {
		T_IN4_ADDR	target, mask, gateway;

		ix = atoi(line);
		while ('0' <= *line && *line <= '9')
			line ++;
		line = GET_IPADDR(&target,  skip_blanks(line));
		line = GET_IPADDR(&mask,    skip_blanks(line));
		       GET_IPADDR(&gateway, skip_blanks(line));
		in4_add_route(ix, target, mask, gateway);
		}

	cons_printf(CONSOLE_PORTID,
	             "Routing Table Status\n"
	             "IX Target          Mask            Gateway\n");

	for (ix = 0; ix < NUM_ROUTE_ENTRY; ix ++) {
		cons_printf(CONSOLE_PORTID, "%2d %15I %15I %I\n",
		            ix,
		            &routing_tbl[ix].target,
		            &routing_tbl[ix].mask,
		            &routing_tbl[ix].gateway);
		            
		}
	}

#endif	/* of #if NUM_ROUTE_ENTRY > 0 */

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

#if NUM_ND6_DEF_RTR_ENTRY > 0

/*
 *  defrtrlist_status -- ǥեȥ롼ꥹȾ֤ν
 */

static void
defrtrlist_status (UB *line)
{
	const T_DEF_ROUTER	*dr;
	SYSTIM			now;
	int			ix;

	cons_printf(CONSOLE_PORTID,
	             "Default Router List Status\n"
	             "IX Expire Lifetime flags IP Address\n");

	/* expire ñ̤ [ms]*/
	syscall(get_tim(&now));
	dr = nd6_get_drl();
	for (ix = 0; ix < NUM_ND6_DEF_RTR_ENTRY; ix ++) {
		if (dr[ix].state != ND6_DEF_RTR_FREE) {
			cons_printf(CONSOLE_PORTID, "%2d %6d %8d    %02x %I\n",
			            ix, 
			            (int)(dr[ix].expire - now) <= 0 ? 0 : (dr[ix].expire - now) / SYSTIM_HZ,
			             dr[ix].lifetime / SYSTIM_HZ,
			             dr[ix].flags,
			            &dr[ix].addr);
			}
		}
	}

#endif	/* of #if NUM_ND6_DEF_RTR_ENTRY > 0 */

#if NUM_ROUTE_ENTRY > 0

/*
 *  routing_table_status -- ϩɽν
 */

static void
routing_table_status (UB *line)
{
	SYSTIM	now;
	int	ix;

	cons_printf(CONSOLE_PORTID,
	             "Routing Table Status\n"
	             "IX Expire flags Prefix Target                         Gateway\n");

	for (ix = 0; ix < NUM_STATIC_ROUTE_ENTRY; ix ++) {
		cons_printf(CONSOLE_PORTID, "%2d STATIC     - %6d %30I %I\n",
		            ix,
		             routing_tbl[ix].prefix_len,
		            &routing_tbl[ix].target,
		            &routing_tbl[ix].gateway);
		            
		}

	/* expire ñ̤ [s]*/
	syscall(get_tim(&now));
	now /= SYSTIM_HZ;

	for ( ; ix < NUM_ROUTE_ENTRY; ix ++)
		if (routing_tbl[ix].flags & IN_RTF_DEFINED)
			cons_printf(CONSOLE_PORTID, "%2d %6d    %02x %6d %30I %I\n",
			            ix,
			            (int)(routing_tbl[ix].expire - now) <= 0 ? 0 : routing_tbl[ix].expire - now,
			             routing_tbl[ix].flags,
			             routing_tbl[ix].prefix_len,
			            &routing_tbl[ix].target,
			            &routing_tbl[ix].gateway);
	}

#endif	/* of #if NUM_ROUTE_ENTRY > 0 */

#endif	/* of #ifdef SUPPORT_INET6 */

#if NUM_ROUTE_ENTRY > 0

/*
 *  routing_status -- 롼ƥ󥰾
 */

static void
routing_status (UB *line)
{
	switch (*line) {

#ifdef SUPPORT_INET6

#if NUM_ND6_DEF_RTR_ENTRY > 0

	case 'l':		/* ǥեȥ롼ꥹȾ */
		defrtrlist_status(line + 1);
		break;

#endif	/* of #if NUM_ND6_DEF_RTR_ENTRY > 0 */

#endif	/* of #ifdef SUPPORT_INET6 */

	default:		/* 롼ƥɽ */
		routing_table_status(line);
		break;

		break;
		}
	}

#endif	/* of #if NUM_ROUTE_ENTRY > 0 */

/*
 *  network_status -- ͥåȥξ֤ν
 */

static void
network_status (UB *line)
{
	switch (*line) {

	case 't':		/* TCP status */
		tcp_status(line + 1);
		break;

	case 'b':		/* ͥåȥХåե */
		nbuf_status(line + 1);
		break;

	case 'c':		/* ͥåȥ׾ */
		net_count(line + 1);
		break;

#ifdef SUPPORT_ETHER

	case 'a':		/* IF ɥ쥹 */
		ifa_status(line + 1);
		break;

#endif	/* of #ifdef SUPPORT_ETHER */

#if NUM_ROUTE_ENTRY > 0

	case 'r':		/* 롼ƥ󥰾 */
		routing_status(line + 1);
		break;

#endif	/* of #if NUM_ROUTE_ENTRY > 0 */

	default:
		syslog(LOG_NOTICE, "no such command: '%c%c'\n", *(line - 1), *line);
		break;
		}
	}

#ifdef SUPPORT_INET4

/*
 *  ifconfig -- ͥåȥ󥿥եι
 */

static void
ifconfig (UB *line)
{
	T_IFNET		*ifp = IF_GET_IFNET();
	T_IN4_ADDR	bc;

#ifdef SUPPORT_ETHER

	if (*(line = skip_blanks(line))) {
		T_IN4_ADDR	addr, mask;

		GET_IPADDR(&mask, skip_blanks(GET_IPADDR(&addr, line)));
		in4_add_ifaddr(addr, mask);
		}

#endif	/* of #ifdef SUPPORT_ETHER */

	cons_printf(CONSOLE_PORTID,
	            "Network Interface Configurations\n");

#ifdef SUPPORT_ETHER

	cons_printf(CONSOLE_PORTID,
	            "ether: %M\n",
	            IF_ETHER_NIC_GET_SOFTC()->ifaddr.lladdr);

#endif	/* of #ifdef SUPPORT_ETHER */

	bc = (ifp->in_ifaddr.addr & ifp->in_ifaddr.mask) | ~ifp->in_ifaddr.mask;
	cons_printf(CONSOLE_PORTID,
	            "inet:  %I, mask: %I, boadcast: %I\n",
	            &ifp->in_ifaddr.addr,
	            &ifp->in_ifaddr.mask,
	            &bc);
	}

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

/*
 *  ifconfig -- ͥåȥ󥿥եι
 */

static void
ifconfig (UB *line)
{
#ifdef SUPPORT_ETHER

	T_IF_SOFTC	*ic;
	T_IFNET		*ifp = IF_GET_IFNET();
	int		ix;
	SYSTIM		now;

	ic = IF_ETHER_NIC_GET_SOFTC();
	cons_printf(CONSOLE_PORTID, "ether: %M\ninet6:\nIX   Expire Lifetime RTR Flags IP Address\n",
	                            ic->ifaddr.lladdr);

	/* expire  vltime ñ̤ [s]*/
	syscall(get_tim(&now));
	now /= SYSTIM_HZ;

	for (ix = 0; ix < MAX_IN6_IFADDR_CNT; ix ++) {
		if (ifp->in_ifaddrs[ix].flags & IN6_IFF_DEFINED) {
			cons_printf(CONSOLE_PORTID, " %d", ix);
			if (ifp->in_ifaddrs[ix].lifetime.vltime == ND6_INFINITE_LIFETIME)
				cons_printf(CONSOLE_PORTID, "    INFIN    INFIN");
			else
				cons_printf(CONSOLE_PORTID, " %8d %8d",
				                            (ifp->in_ifaddrs[ix].lifetime.expire - now),
				                             ifp->in_ifaddrs[ix].lifetime.vltime);

			if (ifp->in_ifaddrs[ix].flags & IN6_IFF_AUTOCONF) {
				if (ifp->in_ifaddrs[ix].rtr_index == IN6_RTR_IX_UNREACH)
					cons_printf(CONSOLE_PORTID, "   *");
				else
					cons_printf(CONSOLE_PORTID, "  %2d", ifp->in_ifaddrs[ix].rtr_index);
				}
			else
				cons_printf(CONSOLE_PORTID, "   -");

			cons_printf(CONSOLE_PORTID, "    %02x %I\n",
			                             ifp->in_ifaddrs[ix].flags,
			                            &ifp->in_ifaddrs[ix].addr);
			}
		}

#endif	/* of #ifdef SUPPORT_ETHER */
	}

#endif	/* of #ifdef SUPPORT_INET6 */

/*
 *  ǥХåޥɲ
 */

static void
dbg_parse (UB *line)
{
	int		cepid;
	T_IN_ADDR	addr;
	ER		error;
	int		tmo;

	switch (*line) {

	case 'i':

		if (*(line + 1) == 'f')
			ifconfig(line + 2);

#ifdef SUPPORT_PPP

#ifdef PPP_CFG_MODEM

		else if (lcp_fsm.state == PPP_FSM_STOPPED)
			dial();		/* initiate */

#else	/* of #ifdef PPP_CFG_MODEM */

		else if (lcp_fsm.state == PPP_FSM_STOPPED)
			lcp_open(PPP_OPEN_ACTIVE);

#endif	/* of #ifdef PPP_CFG_MODEM */

#endif	/* of #ifdef SUPPORT_PPP */

		break;

#ifdef SUPPORT_PPP

	case 'd':		/* disconnect */
		if (lcp_fsm.state != PPP_FSM_STOPPED)
			lcp_close();
		break;

#endif	/* of #ifdef SUPPORT_PPP */

	case 'p':		/* ping or task status */

		if (*(line + 1) == 's')
			task_status(skip_blanks(line + 2));
		else {
			tmo = atoi(skip_blanks(GET_IPADDR(&addr, skip_blanks(line + 1))));
			if (tmo <= 0)
				tmo = 10;
			PING(&addr, tmo, 64);
			}
		break;

	case 'n':		/* network status */
		network_status(line + 1);
		break;

#if defined(USE_UDP_ECHO_CLI) || defined(USE_TCP_ECHO_CLI)

	case 'e':	/* echo client */
		switch (*(line + 1)) {

#ifdef USE_UDP_ECHO_CLI

		case 'u':	/* UDP echo client */
			line += 2;
			if ((error = psnd_dtq(DTQ_UDP_ECHO_CLI, (VP_INT)line)) != E_OK)
				syslog(LOG_NOTICE, "[UDP ECHO CON] error: %s",
				       itron_strerror(error));
			break;

#endif	/* of #ifdef USE_UDP_ECHO_CLI */

#ifdef USE_TCP_ECHO_CLI

		case 't':	/* TCP echo client */
			line += 2;
			if ((error = psnd_dtq(DTQ_TCP_ECHO_CLI, (VP_INT)line)) != E_OK)
				syslog(LOG_NOTICE, "[TCP ECHO CON] error: %s",
				       itron_strerror(error));
			break;

		case 's':	/* cancel TCP echo */
			tcp_echo_cli_valid = FALSE;
			break;

#endif	/* of #ifdef USE_TCP_ECHO_CLI */

			}

		break;

#endif	/* of #if defined(USE_UDP_ECHO_CLI) || defined(USE_TCP_ECHO_CLI) */

#if defined(USE_UDP_DISCARD_CLI) || defined(USE_TCP_DISCARD_CLI)

	case 'b':	/* discard client */
		switch (*(line + 1)) {

#ifdef USE_UDP_DISCARD_CLI

		case 'u':	/* UDP discard client */
			line += 2;
			if ((error = psnd_dtq(DTQ_UDP_DISCARD_CLI, (VP_INT)line)) != E_OK)
				syslog(LOG_NOTICE, "[UDP DISCARD CON] error: %s",
				       itron_strerror(error));
			break;

#endif	/* of #ifdef USE_UDP_DISCARD_CLI */

#ifdef USE_TCP_DISCARD_CLI

		case 't':	/* TCP discard client */
			line += 2;
			if ((error = psnd_dtq(DTQ_TCP_DISCARD_CLI, (VP_INT)line)) != E_OK)
				syslog(LOG_NOTICE, "[TCP DISCARD CON] error: %s",
				       itron_strerror(error));

			break;

		case 's':	/* cancel TCP discard client */
			tcp_discard_cli_valid = FALSE;
			break;

#endif	/* of #ifdef USE_TCP_DISCARD_CLI */

			}

		break;

#endif	/* of #if defined(USE_UDP_DISCARD_CLI) || defined(USE_TCP_DISCARD_CLI) */

#if defined(SUPPORT_TCP) || defined(SUPPORT_UDP)

	case 'c':		/* cancel CEP */
		switch (*(line + 1)) {

#ifdef SUPPORT_UDP

		case 'u':	/* cancel UDP */
			cepid = atoi(line = skip_blanks(line + 2));
			while ('0' <= *line && *line <= '9')
				line ++;
			if ((error = udp_can_cep(cepid, atoi(skip_blanks(line)))) != E_OK)
				syslog(LOG_NOTICE, "[UDP CAN CEP] error: %s",
				       itron_strerror(error));
			break;

#endif	/* of #ifdef SUPPORT_UDP */

#ifdef SUPPORT_TCP

		case 't':	/* cancel TCP */
			cepid = atoi(line = skip_blanks(line + 2));
			while ('0' <= *line && *line <= '9')
				line ++;
			if ((error = tcp_can_cep(cepid, atoi(skip_blanks(line)))) != E_OK)
				syslog(LOG_NOTICE, "[TCP CAN CEP] error: %s",
				       itron_strerror(error));
			break;

#endif	/* of #ifdef SUPPORT_TCP */

			}

		break;

#endif	/* of #if defined(SUPPORT_TCP) || defined(SUPPORT_UDP) */



	case 'r':		/* release wait task */
		syscall(rel_wai(atoi(skip_blanks(line + 1))));
		break;
	case 'w':		/* wake up task */
		syscall(wup_tsk(atoi(skip_blanks(line + 1))));
		break;

	default:

		if (*line) {
#ifdef USE_EXTRA_PARSE

			extra_parse(line);

#else	/* of #ifdef USE_EXTRA_PARSE */

			syslog(LOG_NOTICE, "no such command: '%c'\n", *line);

#endif	/* of #ifdef USE_EXTRA_PARSE */

			}
		break;
		}
	}

/*
 *  ǥХå󥽡륿
 */

void
dbg_con_task (VP_INT exinf)
{
	static UB line[DBG_LINE_SIZE + 1];

	int	len;
	ID	tskid;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[CONSOLE:%d] started.", tskid);
	syscall(serial_ctl_por(CONSOLE_PORTID,
	                       IOCTL_ECHO  | IOCTL_CRLF  |
	                       IOCTL_FCSND | IOCTL_FCANY | IOCTL_FCRCV));
	while (TRUE) {
		len = cons_getline(line, DBG_LINE_SIZE);
		dbg_parse(line);
		}
	}
