/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tcp_echo_srv2.c,v 1.2.1.1 2004/10/13 05:59:09 abe Exp abe $
 */

/* 
 *  TCP ECHO  #2
 *
 *    ʬΥ
 *    Υ֥å󥰥
 *    IPv4/IPv6
 */

#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#include <netinet/in.h>
#include <netinet/in_itron.h>

#include <netapp/netapp.h>
#include <netapp/netapp_var.h>
#include <netapp/echo.h>

/*
 *  ɽ
 */

/*#define SHOW_RCV_RANGE*/

/*
 *  ͥˡλ
 */

/*#define USE_TCP_SHT_CEP*/

/*
 *  ѿ
 */

/*
 *  !!
 *  BUF_SIZE  TCP 
 *  ɥХåե + ɥХåե
 *  礭ʤСǥåɥåǽ롣
 */

#define BUF_SIZE	2048 * 3

static UB 		buffer[BUF_SIZE];	/* Хåե		*/
static UB 		*rptr = buffer;		/* ݥ		*/
static UB 		*sptr = buffer;		/* ݥ		*/
static int		chars;			/* Хåեʸ	*/
static int		rcv_count;		/* 		*/
static int		snd_count;		/* 		*/
static int		rcv_total;		/* ʸ		*/
static int		snd_total;		/* ʸ		*/
static BOOL		ena_rcv;		/* ǽե饰	*/
static T_IPEP		dst;			/* ³		*/

#ifdef USE_TCP_NON_BLOCKING

static ER		rcv_error = E_OK;	/* Υ֥å󥰥륨顼 */
static ER		snd_error = 1;		/* Υ֥å󥰥륨顼 */

/*
 *  Υ֥å󥰥ΥХåؿ
 */

ER
callback_nblk_tcp_echo_srv (ID cepid, FN fncd, VP p_parblk)
{
	static UB addr[sizeof("0123:4567:89ab:cdef:0123:4567:89ab:cdef")];

	ER	error = E_OK;
	int	last, slen, rlen;
	UB	head, tail;
	SYSTIM	now;

	get_tim(&now);

	switch (fncd) {

	case TFN_TCP_ACP_CEP:
		rcv_error = (ER)p_parblk;
		if (rcv_error == E_OK) {
			sptr = rptr = buffer;
			snd_count = snd_total = rcv_count = rcv_total = chars = 0;
			snd_error = 1;
			ena_rcv   = TRUE;
			IP2STR(addr, &dst.ipaddr);
			syslog(LOG_NOTICE, "[TES:%02d CBN] connected:  %6d, from: %s.%d",
			                   cepid, now / SYSTIM_HZ, addr, dst.portno);
			}
		else
			syslog(LOG_NOTICE, "[TES:%02d CBN] accept error: %s\n", cepid, itron_strerror(rcv_error));

		syscall(sig_sem(SEM_TCP_ECHO_SRV_RCV_READY));
		break;

	case TFN_TCP_SND_DAT:
		slen = snd_error = (ER)p_parblk;
		if (slen > 0) {
			head = *sptr;
			tail = *(sptr + slen - 1);
#ifdef SHOW_RCV_RANGE
			syslog(LOG_NOTICE, "[TES:%02d CBN] send len: %4d, data %02x -> %02x",
			                   cepid, slen, head, tail);
#endif	/* of #ifdef SHOW_RCV_RANGE */
			snd_count ++;
			snd_total += slen;

			syscall(wai_sem(SEM_TCP_ECHO_SRV_LOCK));

			/* ݥ󥿤ʤ롣*/
			if (sptr - buffer + slen >= sizeof(buffer))
				sptr -= sizeof(buffer) - slen;
			else
				sptr += slen;

			/* Хåեʸ򸺤餹*/
			last   = chars;
			chars -= slen;

 			/* ХåեʸС򵯾롣*/
			if (chars > 0 || (!ena_rcv && chars == 0))
				sig_sem(SEM_TCP_ECHO_SRV_SND_READY);

 			/* ǽǡХåե˶ǤС򵯾롣*/
			if (ena_rcv && last == sizeof(buffer) && sizeof(buffer) - chars > 0)
				syscall(sig_sem(SEM_TCP_ECHO_SRV_RCV_READY));

			syscall(sig_sem(SEM_TCP_ECHO_SRV_LOCK));
			}
		else {
			syslog(LOG_NOTICE, "[TES:%02d CBN] send error = %s", cepid, itron_strerror(snd_error));
			sig_sem(SEM_TCP_ECHO_SRV_SND_READY);
			}
		break;

	case TFN_TCP_RCV_DAT:
		rlen = rcv_error = (ER)p_parblk;
		if (rlen > 0) {
			head = *rptr;
			tail = *(rptr + rlen - 1);
#ifdef SHOW_RCV_RANGE
			syslog(LOG_NOTICE, "[TES:%02d CBN] recv len: %4d, data %02x -> %02x",
			                   cepid, rlen, head, tail);
#endif	/* of #ifdef SHOW_RCV_RANGE */
			rcv_count ++;
			rcv_total += rlen;

			syscall(wai_sem(SEM_TCP_ECHO_SRV_LOCK));

			/* ݥ󥿤ʤ롣*/
			if (rptr - buffer + rlen >= sizeof(buffer))
				rptr -= sizeof(buffer) - rlen;
			else
				rptr += rlen;

			/* Хåեʸ䤹*/
			last   = chars;
			chars += rlen;

 			/* ХåեʸС򵯾롣*/
			if (last == 0 && chars > 0)
				sig_sem(SEM_TCP_ECHO_SRV_SND_READY);

 			/* Хåե˶С򵯾롣*/
			if (sizeof(buffer) - chars > 0)
				sig_sem(SEM_TCP_ECHO_SRV_RCV_READY);

			syscall(sig_sem(SEM_TCP_ECHO_SRV_LOCK));
			}
		else {
			if (rlen < 0)
				syslog(LOG_NOTICE, "[TES:%02d CBN] recv error = %s", cepid, itron_strerror(rcv_error));
			sig_sem(SEM_TCP_ECHO_SRV_RCV_READY);
			}
		break;

	case TFN_TCP_CLS_CEP:
		snd_error = (ER)p_parblk;
		if (snd_error != E_OK)
			syslog(LOG_NOTICE, "[TES:%02d CBN] close error = %s", cepid, itron_strerror(snd_error));

		syslog(LOG_NOTICE, "[TES:%02d CBN] finished:   %6d, snd: %4d, rcv: %4d, len: %d",
		                   cepid, now / SYSTIM_HZ, snd_count, rcv_count, snd_total);

		sig_sem(SEM_TCP_ECHO_SRV_CLS_READY);
		break;

	case TFN_TCP_CON_CEP:
	case TFN_TCP_GET_BUF:
	case TFN_TCP_RCV_BUF:
	case TFN_TCP_SND_OOB:
	default:
		error = E_PAR;
		}
	return error;
	}

/*
 *  TCP ECHO м (Υ֥å󥰥)
 */

void
tcp_echo_srv_rcv_task(VP_INT exinf)
{
	ER	error;
	ID	tskid;
	int	blen;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) RCV:%d,%d] started.", tskid, (ID)exinf);
	syscall(act_tsk(TCP_ECHO_SRV_SND_TASK));
	while (TRUE) {
		if ((error = TCP_ACP_CEP((ID)exinf, TCP_ECHO_SRV_REPID, &dst, TMO_NBLK)) != E_WBLK) {
			syslog(LOG_NOTICE, "[TES:%02d RCV] accept error = %s", (ID)exinf, itron_strerror(error));
			continue;
			}

		/* ͥߴλޤԤġ*/
		syscall(wai_sem(SEM_TCP_ECHO_SRV_RCV_READY));

		/* ԤäƤ֤˥顼ˤʤä顢ͥγԤ롣*/
		if (rcv_error != E_OK)
			continue;

		while (TRUE) {

			/* ׻롣*/
			syscall(wai_sem(SEM_TCP_ECHO_SRV_LOCK));
			if (sptr > rptr)
				blen = sptr - rptr;
			else
				blen = sizeof(buffer) - (rptr - buffer);
			syscall(sig_sem(SEM_TCP_ECHO_SRV_LOCK));

			/* 롣*/
			if ((error = tcp_rcv_dat((ID)exinf, rptr, blen, TMO_NBLK)) != E_WBLK) {
				syslog(LOG_NOTICE, "[TES:%02d RCV] recv error = %s", (ID)exinf, itron_strerror(error));
				break;
				}

			/* Хåե˶ǤޤԤġ*/
			syscall(wai_sem(SEM_TCP_ECHO_SRV_RCV_READY));

			/* ԤäƤ֤ˡʸ 0 ˤʤ뤫顼ˤʤä齪λ롣*/
			if (rcv_error <= 0)
				break;

			}

		/* λ */
		ena_rcv = FALSE;

		/* ХåեʸΤԤäƤ򵯾롣*/
		if (chars == 0)
			sig_sem(SEM_TCP_ECHO_SRV_SND_READY);

		/* ͥǴλޤԤġ*/
		syscall(wai_sem(SEM_TCP_ECHO_SRV_CLS_READY));
		}
	}

/*
 *  TCP ECHO  (Υ֥å󥰥)
 */

void
tcp_echo_srv_snd_task(VP_INT exinf)
{
	ER	error;
	ID	tskid;
	int	blen;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) SND:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {

		while (TRUE) {

			/* ХåեʸޤԤġ*/
			syscall(wai_sem(SEM_TCP_ECHO_SRV_SND_READY));

			/* ԤäƤ֤˥顼ˤʤä齪λ롣*/
			if (snd_error <= 0)
				break;

			/* λǡХåեʸʤнλ롣*/
			if (!ena_rcv && chars == 0)
				break;

			/* ׻롣*/
			syscall(wai_sem(SEM_TCP_ECHO_SRV_LOCK));
			if (rptr > sptr)
				blen = rptr - sptr;
			else
				blen = sizeof(buffer) - (sptr - buffer);
			syscall(sig_sem(SEM_TCP_ECHO_SRV_LOCK));

			/* 롣*/
			if ((error = tcp_snd_dat((ID)exinf, sptr, blen, TMO_NBLK)) != E_WBLK) {
				syslog(LOG_NOTICE, "[TES:%02d SND] send error = %s", (ID)exinf, itron_strerror(error));
				break;
				}
			}

		/* Хåե˶ǤԤäƤ򵯾롣*/
		if (chars == sizeof(buffer))
			sig_sem(SEM_TCP_ECHO_SRV_SND_READY);

#ifdef USE_TCP_SHT_CEP
		if ((error = tcp_sht_cep((ID)exinf)) != E_OK)
			syslog(LOG_NOTICE, "[TES:%02d SND] shutdown error = %s", (ID)exinf, itron_strerror(error));
#endif	/* of #ifdef USE_TCP_SHT_CEP */

		if ((error = tcp_cls_cep((ID)exinf, TMO_NBLK)) != E_WBLK) {
			syslog(LOG_NOTICE, "[TES:%02d SND] close error = %s", (ID)exinf, itron_strerror(error));
			}

		pol_sem(SEM_TCP_ECHO_SRV_SND_READY);
		pol_sem(SEM_TCP_ECHO_SRV_RCV_READY);
		}
	}

#else	/* of #ifdef USE_TCP_NON_BLOCKING */

/*
 *  TCP ECHO м
 */

void
tcp_echo_srv_rcv_task(VP_INT exinf)
{
	static UB addr[sizeof("0123:4567:89ab:cdef:0123:4567:89ab:cdef")];

	ER_UINT	rlen;
	ER	error;
	int	blen, last;
	ID	tskid;
	UB	head, tail;
	SYSTIM	now;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO SRV RCV:%d,%d] started.", tskid, (ID)exinf);
	syscall(act_tsk(TCP_ECHO_SRV_SND_TASK));
	while (TRUE) {
		if ((error = TCP_ACP_CEP((ID)exinf, TCP_ECHO_SRV_REPID, &dst, TMO_FEVR)) != E_OK)
			syslog(LOG_NOTICE, "[TES:%02d RCV] accept error = %s", (ID)exinf, itron_strerror(error));
		else {
			get_tim(&now);
			sptr = rptr = buffer;
			snd_count = snd_total = rcv_count = rcv_total = chars = 0;
			ena_rcv   = TRUE;
			IP2STR(addr, &dst.ipaddr);
			syslog(LOG_NOTICE, "[TES:%02d RCV] connected:  %6d, from: %s.%d",
			                   (ID)exinf, now / SYSTIM_HZ, addr, dst.portno);
			while (TRUE) {

				/* ׻롣*/
				syscall(wai_sem(SEM_TCP_ECHO_SRV_LOCK));
				if (sptr > rptr)
					blen = sptr - rptr;
				else
					blen = sizeof(buffer) - (rptr - buffer);
				syscall(sig_sem(SEM_TCP_ECHO_SRV_LOCK));

				/* 롣*/
				if ((rlen = tcp_rcv_dat((ID)exinf, rptr, blen, TMO_FEVR)) <= 0) {
					if (rlen < 0)
						syslog(LOG_NOTICE, "[TES:%02d RCV] recv error = %s",
						                   (ID)exinf, itron_strerror(rlen));
					break;
					}
				head = *rptr;
				tail = *(rptr + rlen - 1);
#ifdef SHOW_RCV_RANGE
				syslog(LOG_NOTICE, "[TES:%02d RCV] len: %4d, data %02x -> %02x",
				                   (ID)exinf, rlen, head, tail);
#endif	/* of #ifdef SHOW_RCV_RANGE */
				rcv_count ++;
				rcv_total += rlen;

				syscall(wai_sem(SEM_TCP_ECHO_SRV_LOCK));

				/* ݥ󥿤ʤ롣*/
				if (rptr - buffer + rlen >= sizeof(buffer))
					rptr -= sizeof(buffer) - rlen;
				else
					rptr += rlen;

				/* Хåեʸ䤹*/
				last   = chars;
				chars += rlen;

 				/* ХåեʸС򵯾롣*/
				if (last == 0 && chars > 0)
					sig_sem(SEM_TCP_ECHO_SRV_SND_READY);

 				/* Хåե˶С򵯾롣*/
				if (sizeof(buffer) - chars > 0)
					sig_sem(SEM_TCP_ECHO_SRV_RCV_READY);

				syscall(sig_sem(SEM_TCP_ECHO_SRV_LOCK));

				/* Хåե˶ǤޤԤġ*/
				syscall(wai_sem(SEM_TCP_ECHO_SRV_RCV_READY));
				}

			/* λ */
			ena_rcv = FALSE;

			/* ХåեʸΤԤäƤ򵯾롣*/
			if (chars == 0)
				sig_sem(SEM_TCP_ECHO_SRV_SND_READY);

			/* ͥǤλޤԤġ*/
			syscall(wai_sem(SEM_TCP_ECHO_SRV_CLS_READY));
			}
		}
	}

/*
 *  TCP ECHO 
 */

void
tcp_echo_srv_snd_task(VP_INT exinf)
{
	ER_UINT	slen;
	int	blen, last;
	ID	tskid;
	ER	error;
	UB	head, tail;
	SYSTIM	now;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO SRV SND:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		while (TRUE) {

			/* ХåեʸޤԤġ*/
			syscall(wai_sem(SEM_TCP_ECHO_SRV_SND_READY));

			/* λǡХåեʸʤнλ롣*/
			if (!ena_rcv && chars == 0)
				break;

			/* ׻롣*/
			syscall(wai_sem(SEM_TCP_ECHO_SRV_LOCK));
			if (rptr > sptr)
				blen = rptr - sptr;
			else
				blen = sizeof(buffer) - (sptr - buffer);
			syscall(sig_sem(SEM_TCP_ECHO_SRV_LOCK));

			if ((slen = tcp_snd_dat((ID)exinf, sptr, blen, TMO_FEVR)) <= 0) {
				syslog(LOG_NOTICE, "[TES:%02d SND] send error = %s", (ID)exinf, itron_strerror(slen));
				break;
				}

			head = *sptr;
			tail = *(sptr + slen - 1);
#ifdef SHOW_RCV_RANGE
			syslog(LOG_NOTICE, "[TES:%02d SND] len: %4d, data %02x -> %02x",
			                   (ID)exinf, slen, head, tail);
#endif	/* of #ifdef SHOW_RCV_RANGE */
			snd_count ++;
			snd_total += slen;

			syscall(wai_sem(SEM_TCP_ECHO_SRV_LOCK));

			/* ݥ󥿤ʤ롣*/
			if (sptr - buffer + slen >= sizeof(buffer))
				sptr -= sizeof(buffer) - slen;
			else
				sptr += slen;

			/* Хåեʸ򸺤餹*/
			last   = chars;
			chars -= slen;

			/* λǡХåեʸʤнλ롣*/
			if (!ena_rcv && chars == 0) {
				syscall(sig_sem(SEM_TCP_ECHO_SRV_LOCK));
				break;
				}

 			/* ХåեʸС򵯾롣*/
			if (chars > 0)
				sig_sem(SEM_TCP_ECHO_SRV_SND_READY);

 			/* ǽǡХåե˶ǤС򵯾롣*/
			if (ena_rcv && last == sizeof(buffer) && sizeof(buffer) - chars > 0)
				sig_sem(SEM_TCP_ECHO_SRV_RCV_READY);

			syscall(sig_sem(SEM_TCP_ECHO_SRV_LOCK));
			}

		/* Хåե˶ǤԤäƤ򵯾롣*/
		if (chars == sizeof(buffer))
			sig_sem(SEM_TCP_ECHO_SRV_SND_READY);

#ifdef USE_TCP_SHT_CEP
		if ((error = tcp_sht_cep((ID)exinf)) != E_OK)
			syslog(LOG_NOTICE, "[TES:%02d SND] shtudown error = %s", (ID)exinf, itron_strerror(error));
#endif	/* of #ifdef USE_TCP_SHT_CEP */

		if ((error = tcp_cls_cep((ID)exinf, TMO_FEVR)) != E_OK)
			syslog(LOG_NOTICE, "[TES:%02d SND] close error = %s", (ID)exinf, itron_strerror(error));

		get_tim(&now);
		syslog(LOG_NOTICE, "[TES:%02d SND] finished:   %6d, snd: %4d, rcv: %4d, len: %d",
		                   (ID)exinf, now / SYSTIM_HZ, snd_count, rcv_count, snd_total);

		sig_sem(SEM_TCP_ECHO_SRV_CLS_READY);

		pol_sem(SEM_TCP_ECHO_SRV_SND_READY);
		pol_sem(SEM_TCP_ECHO_SRV_RCV_READY);
		}
	}

#endif	/* of #ifdef USE_TCP_NON_BLOCKING */
