/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: ip_var.h,v 1.2.1.6 2006/01/29 04:44:07 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)ip_var.h	8.2 (Berkeley) 1/9/95
 * $FreeBSD: src/sys/netinet/ip_var.h,v 1.45.2.1 1999/08/29 16:29:51 peter Exp $
 */
 
#ifndef _IP_VAR_H_
#define _IP_VAR_H_

/*
 *  IPv4 إåڥɥޥ
 */

#define IF_IP4_HDR_SIZE			(sizeof(T_IF_HDR) + IP4_HDR_SIZE)

#define GET_IP4_HDR(nbuf)		((T_IP4_HDR*)((nbuf)->buf + sizeof(T_IF_HDR)))
#define GET_IP4_SDU(nbuf)		((UB*)((nbuf)->buf) + GET_IF_IP4_HDR_SIZE(nbuf))

#define GET_IP4_HDR_SIZE(iph)		(IP4_VHL_HL((iph)->vhl) << 2)
#define GET_IP4_SDU_SIZE(iph)		(ntohs((iph)->len) - GET_IP4_HDR_SIZE(iph))
#define GET_IF_IP4_HDR_SIZE(nbuf)	(sizeof(T_IF_HDR) + (GET_IP4_HDR_SIZE(GET_IP4_HDR(nbuf))))

#define SET_IP4_SDU_SIZE(iph,slen)	((iph)->len=htons((slen) + IP4_HDR_SIZE))

#ifdef IP4_CFG_FRAGMENT

/*
 *  ƹ塼 IPv4 إå
 */

typedef struct t_qip4_hdr {
	UB	vhl;		/* version << 4 | header length >> 2	*/
				/* length  4 octets ñ		*/
	UB	type;		/* type of services			*/
	UH	len;		/* total length				*/

	UH	id;		/* identification			*/
	UH	flg_off;	/* fragment flag & offset		*/

	UB	ttl;		/* time to live				*/
	UB	proto;		/* protocol				*/
	UH	sum;		/* checksum				*/

	UW	src;		/* source address			*/

	T_NET_BUF	*next;	/*  IPv4 ե饰			*/
	} T_QIP4_HDR;

#define QIP4_HDR_SIZE			(sizeof(T_QIP4_HDR))
#define IF_QIP4_HDR_SIZE		(sizeof(T_IF_HDR) + QIP4_HDR_SIZE)

#define GET_QIP4_HDR(nbuf)		((T_QIP4_HDR*)((nbuf)->buf + sizeof(T_IF_HDR)))
#define GET_QIP4_SDU(nbuf)		((UB*)(nbuf)->buf + GET_IF_QIP4_HDR_SIZE(nbuf))

#define GET_QIP4_HDR_SIZE(iph)		(IP4_VHL_HL((iph)->vhl) << 2)
#define GET_IF_QIP4_HDR_SIZE(nbuf)	(sizeof(T_IF_HDR) + (GET_QIP4_HDR_SIZE(GET_QIP4_HDR(nbuf))))

#endif	/* of #ifdef IP4_CFG_FRAGMENT */

/*
 *  IPv4  IPv6 򥳥ѥ򤹤뤿Υޥ
 */

#ifdef SUPPORT_INET4

#define IF_IP_HDR_SIZE			IF_IP4_HDR_SIZE

#define GET_IP_HDR(nbuf)		GET_IP4_HDR(nbuf)
#define GET_IP_SDU(nbuf)		GET_IP4_SDU(nbuf)

#define GET_IP_HDR_SIZE(iph)		GET_IP4_HDR_SIZE(iph)
#define GET_IP_SDU_SIZE(iph)		GET_IP4_SDU_SIZE(iph)
#define GET_IF_IP_HDR_SIZE(nbuf)	GET_IF_IP4_HDR_SIZE(nbuf)

#define SET_IP_SDU_SIZE(iph,len)	SET_IP4_SDU_SIZE(iph,len)

#define IP_OUTPUT(nbuf,tmout)		ip_output(nbuf,tmout)
#define IP_INIT()			ip_init()
#define IP_REMOVE_OPTIONS(nbuf)		ip_remove_options(nbuf)
#define IP_UPDATE_SDU_LEN(iph,diff)	((iph)->len=htons(ntohs((iph)->len)-(diff)))

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_MIB

/*
 *  SNMP  ١ (MIB)
 */

typedef struct t_ip_stats {
	UW	ipInReceives;
	UW	ipInHdrErrors;
	UW	ipInAddrErrors;
/*	UW	ipForwDatagrams;*/
	UW	ipInUnknownProtos;
/*	UW	ipInDiscards;*/
	UW	ipInDelivers;
	UW	ipOutRequests;
	UW	ipOutDiscards;
/*	UW	ipOutNoRoutes;*/

#ifdef IP4_CFG_FRAGMENT

	UW	ipReasmReqds;
	UW	ipReasmOKs;
	UW	ipReasmFails;
	UW	ipFragOKs;
	UW	ipFragFails;
	UW	ipFragCreates;

#else	/* of #ifdef IP4_CFG_FRAGMENT */

	UW	ipReasmReqds;
/*	UW	ipReasmOKs;*/
	UW	ipReasmFails;
/*	UW	ipFragOKs;*/
/*	UW	ipFragFails;*/
/*	UW	ipFragCreates;*/

#endif	/* of #ifdef IP4_CFG_FRAGMENT */

} T_IP_STATS;

extern T_IP_STATS ip_stats;

#endif	/* of #ifdef SUPPORT_MIB */

/*
 *  ؿ
 */

extern void ip_frag_timer (void);
extern void ip_init (void);
extern ER ip_remove_options (T_NET_BUF *nbuf);
extern ER ip_output (T_NET_BUF *nbuf, TMO tmout);

#endif	/* of #ifndef _IP_VAR_H_ */
