/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tcp_usrreq.c,v 1.2.1.6 2006/01/29 04:44:07 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1988, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	From: @(#)tcp_usrreq.c	8.2 (Berkeley) 1/3/94
 * $FreeBSD: src/sys/netinet/tcp_usrreq.c,v 1.40.2.3 1999/08/29 16:29:57 peter Exp $
 */

#include <string.h>

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/ppp_ipcp.h>
#include <net/net.h>
#include <net/net_var.h>
#include <net/net_buf.h>
#include <net/net_timer.h>
#include <net/net_count.h>

#include <netinet/in.h>
#include <netinet/in_var.h>
#include <netinet6/in6.h>
#include <netinet6/in6_var.h>
#include <netinet/in_itron.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <netinet/tcp_timer.h>
#include <netinet/tcp_var.h>
#include <netinet/tcp_fsm.h>
#include <netinet/tcp_seq.h>

#include <net/if_var.h>

/*
 *  ؿ
 */

static T_TCP_CCEP *user_closed (T_TCP_CCEP *cep);
static ER tcp_lock_cep (ID cepid, T_TCP_CCEP **p_cep, INT tfn);
static ER tcp_can_snd (T_TCP_CCEP *cep, FN fncd);
static ER tcp_can_rcv (T_TCP_CCEP *cep, FN fncd);

/*
 *  user_closed -- 桼Υͥγ
 */

static T_TCP_CCEP *
user_closed (T_TCP_CCEP *cep)
{
	switch (cep->fsm_state) {

	case TCP_FSM_CLOSED:		/* 	*/
	case TCP_FSM_LISTEN:		/* ưץ	*/
		cep->fsm_state = TCP_FSM_CLOSED;
		cep = tcp_close(cep);
		break;

	case TCP_FSM_SYN_SENT:		/* ǽưץSYN Ѥ	*/
	case TCP_FSM_SYN_RECVD:		/* SYN SYN Ѥ	*/
		cep->flags |= CEP_FLG_NEED_FIN;
		break;

	case TCP_FSM_ESTABLISHED:	/* ͥߴλ	*/
		cep->fsm_state = TCP_FSM_FIN_WAIT_1;
		break;

	case TCP_FSM_CLOSE_WAIT:	/* ꤫ FIN APP νλԤ */
		cep->fsm_state = TCP_FSM_LAST_ACK;
		break;
		}

	if (cep != NULL && cep->fsm_state == TCP_FSM_FIN_WAIT_2)
		cep->timer[TCP_TIM_2MSL] = TCP_TVAL_KEEP_COUNT * TCP_TVAL_KEEP_INTERVAL;
	return cep;
	}

/*
 *  tcp_lock_cep -- TCP ̿üå롣
 */

static ER
tcp_lock_cep (ID cepid, T_TCP_CCEP **p_cep, FN tfn)
{
	T_TCP_CCEP	*cep;
	ER		error = E_OK;

	*p_cep = NULL;

	/* TCP ̿üå롣*/
	if (!VALID_TCP_CCEPID(cepid))
		return E_ID;

	/* TCP ̿ü롣*/
	cep = GET_TCP_CCEP(cepid);

	/*
	 *  CEP åAPI ǽɤȥ̻ҤϿ롣
	 *  Ǥ˵ϿƤСڥǥʤΤǥ顼
	 */
	syscall(wai_sem(cep->semid_lock));

	if (IS_TFN_TCP_RCV(tfn)) {
		if (cep->rcv_tfn != TFN_TCP_UNDEF ||
		    (tfn == TFN_TCP_ACP_CEP && cep->snd_tfn == TFN_TCP_CON_CEP)) 
			error = E_OBJ;
		else {
			get_tid(&(cep->rcv_tskid));
			cep->rcv_tfn = tfn;
			}
		}
	else {
		if (cep->snd_tfn != TFN_TCP_UNDEF ||
		    (tfn == TFN_TCP_CON_CEP && cep->rcv_tfn == TFN_TCP_ACP_CEP) ||
		    (tfn == TFN_TCP_CON_CEP && cep->rcv_tfn == TFN_TCP_CLS_CEP))
			error = E_OBJ;
		else {
			get_tid(&(cep->snd_tskid));
			cep->snd_tfn = tfn;
			}
		}

	syscall(sig_sem(cep->semid_lock));

	*p_cep = cep;
	return error;
	}

/*
 *  tcp_can_snd -- ڥǥ󥰤ƤΥ󥻥
 */

static ER
tcp_can_snd (T_TCP_CCEP *cep, FN fncd)
{
	ER	error = E_OK;


	/* CEP å롣*/
	syscall(wai_sem(cep->semid_lock));

	/*
	 *  snd_tskid  TA_NULL ʤ顢
	 *  ڥǥ󥰤ƤʤΤǥ顼
	 */
	if (cep->snd_tskid == TA_NULL)
		error = EV_NOPND;

	/* ڥǥ API ǽɤȰפʤХ顼 */
	else if (fncd != TFN_TCP_ALL && fncd != cep->snd_tfn)
		error = E_OBJ;

	/* 򥭥󥻥뤹롣*/
	else {
		if (cep->snd_nblk_tfn != TFN_TCP_UNDEF) {	/* Υ֥å󥰥 */

			switch (cep->snd_nblk_tfn) {

			case TFN_TCP_CON_CEP:
				cep->rep = NULL;
				cep->fsm_state = TCP_FSM_CLOSED;
				syscall(set_flg(cep->flgid, CEP_EVT_CLOSED));
				break;

			case TFN_TCP_SND_DAT:
			case TFN_TCP_GET_BUF:
			case TFN_TCP_SND_OOB:
				break;
				}

			if (cep->callback == NULL)
				syslog(LOG_WARNING, "[tcp_can_snd] no call back.");
			else
				(*cep->callback)(GET_TCP_CCEPID(cep), cep->snd_nblk_tfn, (VP)E_RLWAI);
			cep->snd_nblk_tfn = TFN_TCP_UNDEF;
			}
		else
			error = rel_wai(cep->snd_tskid);

		cep->snd_tskid = TA_NULL;
		cep->snd_tfn   = TFN_TCP_UNDEF;
		}

	/* CEP Υå롣*/
	syscall(sig_sem(cep->semid_lock));

	return error;
	}

/*
 *  tcp_can_rcv -- ڥǥ󥰤ƤΥ󥻥
 */

static ER
tcp_can_rcv (T_TCP_CCEP *cep, FN fncd)
{
	ER	error = E_OK;


	/* CEP å롣*/
	syscall(wai_sem(cep->semid_lock));

	/*
	 *  rcv_tskid  TA_NULL ʤ顢
	 *  ڥǥ󥰤ƤʤΤǥ顼
	 */
	if (cep->rcv_tskid == TA_NULL)
		error = EV_NOPND;

	/* ڥǥ API ǽɤȰפʤХ顼 */
	else if (fncd != TFN_TCP_ALL && fncd != cep->rcv_tfn)
		error = E_OBJ;

	/* 򥭥󥻥뤹롣*/
	else {
		if (cep->rcv_nblk_tfn != TFN_TCP_UNDEF) {	/* Υ֥å󥰥 */

			switch (cep->rcv_nblk_tfn) {

			case TFN_TCP_ACP_CEP:
				/*
				 *  ̿üո̿üꥹȤ鳰
				 *  ٥ȥե饰򥯥ꤹ롣
				 */
				cep->rep = NULL;
				cep->fsm_state = TCP_FSM_CLOSED;
				syscall(set_flg(cep->flgid, CEP_EVT_CLOSED));
				break;

			case TFN_TCP_RCV_DAT:
			case TFN_TCP_RCV_BUF:
				break;

			case TFN_TCP_CLS_CEP:
				cep->fsm_state = TCP_FSM_CLOSED;
				tcp_respond(NULL, cep, cep->rcv_nxt, cep->snd_una - 1, TCP_FLG_RST, TMO_TCP_OUTPUT);
				cep->rep = NULL;
				syscall(set_flg(cep->flgid, CEP_EVT_CLOSED));
				break;
				}

			if (cep->callback == NULL)
				syslog(LOG_WARNING, "[tcp_can_rcv] no call back.");
			else
				(*cep->callback)(GET_TCP_CCEPID(cep), cep->rcv_nblk_tfn, (VP)E_RLWAI);
			cep->rcv_nblk_tfn = TFN_TCP_UNDEF;
			}
		else
			error = rel_wai(cep->rcv_tskid);

		cep->rcv_tskid = TA_NULL;
		cep->rcv_tfn   = TFN_TCP_UNDEF;
		}

	/* CEP Υå롣*/
	syscall(sig_sem(cep->semid_lock));

	return error;
	}

/*
 *  tcp_acp_cep -- ³׵Ԥ (ưץ)ɸൡǽ
 */

#ifdef SUPPORT_INET4

ER
tcp_acp_cep (ID cepid, ID repid, T_IPV4EP *p_dstaddr, TMO tmout)

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

ER
tcp6_acp_cep (ID cepid, ID repid, T_IPV6EP *p_dstaddr, TMO tmout)

#endif	/* of #ifdef SUPPORT_INET6 */
{
	T_TCP_CREP	*rep;
	T_TCP_CCEP	*cep;
	ER		error;
	FLGPTN		flag;

	/* TCP ոå롣*/
	if (!VALID_TCP_CREPID(repid))
		return E_ID;

	/* p_dstaddr  NULL ʤ饨顼 */
	if (p_dstaddr == NULL)
		return E_PAR;

	/*
	 *  CEP åAPI ǽɤȥ̻ҤϿ롣
	 *  Ǥ˵ϿƤСڥǥʤΤǥ顼
	 */
	if ((error = tcp_lock_cep(cepid, &cep, TFN_TCP_ACP_CEP)) != E_OK)
		return error;

	/* CEP  FSM ֤ǤʤХ顼*/
	if (cep->fsm_state != TCP_FSM_CLOSED) {
		error = E_OBJ;
		goto err_ret;
		}
	syscall(clr_flg(cep->flgid, ~CEP_EVT_CLOSED));

	/* ̿ü롣*/
	tcp_init_cep(cep);

	/* TCP ոơ̿ü˼ոϿ롣*/
	rep = GET_TCP_CREP(repid);
	cep->rep = rep;

	/* TCP ոΥɥ쥹򥳥ԡ롣*/
	cep->myaddr = rep->myaddr;

	/* ̿üꤹ롣*/
	cep->fsm_state = TCP_FSM_LISTEN;

	/* ॢȤå롣*/
	if (tmout == TMO_NBLK) {
		/* Υ֥å󥰥 */
		cep->p_dstaddr    = p_dstaddr;
		cep->rcv_nblk_tfn = TFN_TCP_ACP_CEP;
		return E_WBLK;
		}
	else {
		/*
		 *  FSM  ESTABLISHED ˤʤޤԤġ
		 *  FSM  CLOSED ˤʤäϡ顼ȯȤ̣Ƥ롣
		 */
		error = twai_flg(cep->flgid, (CEP_EVT_CLOSED |
		                              CEP_EVT_ESTABLISHED), TWF_ORW, &flag, tmout);
		if (error == E_OK) {
			if (cep->error != E_OK)
				error = cep->error;
			else if (cep->fsm_state == TCP_FSM_CLOSED)
				error = E_TMOUT;
			}

		syscall(clr_flg(cep->flgid, ~CEP_EVT_ESTABLISHED));

		if (error == E_OK) {
			/* Υɥ쥹򥳥ԡ롣*/
			*p_dstaddr = cep->dstaddr;
			}
		else {
			/*
			 *  ̿üո̿üꥹȤ鳰
			 *  ٥ȥե饰򥯥ꤹ롣
			 */
			cep->rep = NULL;
			cep->fsm_state = TCP_FSM_CLOSED;
			syscall(set_flg(cep->flgid, CEP_EVT_CLOSED));
			}
		}

err_ret:
	cep->rcv_tskid = TA_NULL;
	cep->rcv_tfn   = TFN_TCP_UNDEF;
	return error;
	}

/*
 *  tcp_con_cep -- ³׵ (ǽưץ)ɸൡǽ
 */

#ifdef SUPPORT_INET4

ER
tcp_con_cep (ID cepid, T_IPV4EP *p_myaddr, T_IPV4EP *p_dstaddr, TMO tmout)

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

ER
tcp6_con_cep (ID cepid, T_IPV6EP *p_myaddr, T_IPV6EP *p_dstaddr, TMO tmout)

#endif	/* of #ifdef SUPPORT_INET6 */
{
	T_TCP_CCEP	*cep;
	ER		error;
	FLGPTN		flag;

	/*
	 *  p_dstaddr ޤ p_myaddr  NULL 
	 *  褬ޥ㥹ȥɥ쥹ʤ饨顼
	 */
	if (p_myaddr == NULL || p_dstaddr == NULL || IN_IS_ADDR_MULTICAST(&p_dstaddr->ipaddr))
		return E_PAR;

	/*
	 *  CEP åAPI ǽɤȥ̻ҤϿ롣
	 *  Ǥ˵ϿƤСڥǥʤΤǥ顼
	 */
	if ((error = tcp_lock_cep(cepid, &cep, TFN_TCP_CON_CEP)) != E_OK)
		return error;

	/* CEP  FSM ֤ǤʤХ顼*/
	if (cep->fsm_state != TCP_FSM_CLOSED) {
		error = E_OBJ;
		goto err_ret;
		}
	syscall(clr_flg(cep->flgid, ~CEP_EVT_CLOSED));

	/* ֹ롣*/
	if (tcp_iss == 0)
		tcp_init_iss();

	/* ̿ü롣*/
	tcp_init_cep(cep);

#ifdef SUPPORT_INET4

	/*
	 *  p_myaddr  NADR (-1) ǤϤʤ IP ɥ쥹 ANY ǤʤС
	 *  ꤵ줿 IP ɥ쥹Ƥ롣
	 */
	if ((int)p_myaddr != NADR && !IN_IS_ADDR_ANY(&p_myaddr->ipaddr))
		cep->myaddr.ipaddr = p_myaddr->ipaddr;
	else
		cep->myaddr.ipaddr = IF_GET_IFNET()->in_ifaddr.addr;

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

	/*
	 *  p_myaddr  NADR (-1) ǤϤʤ IP ɥ쥹 ANY ǤʤС
	 *  ꤵ줿 IP ɥ쥹Ƥ롣
	 */
	if ((int)p_myaddr != NADR && !IN_IS_ADDR_ANY(&p_myaddr->ipaddr))
		cep->myaddr.ipaddr = p_myaddr->ipaddr;
	else {
		T_IN6_IFADDR	*ia;

		if ((ia = in6_ifawithifp(IF_GET_IFNET(), &p_dstaddr->ipaddr)) == NULL) {
			error = E_PAR;
			goto err_ret;
			}
		cep->myaddr.ipaddr = ia->addr;
		}

#endif	/* of #ifdef SUPPORT_INET6 */

	/* ̿üꤹ롣*/
	cep->fsm_state = TCP_FSM_SYN_SENT;
	cep->dstaddr   = *p_dstaddr;
	cep->iss       = tcp_iss;
	cep->timer[TCP_TIM_KEEP] = TCP_TVAL_KEEP_IDLE;
	tcp_iss += TCP_ISS_INCR() / 2;
	init_send_seq(cep);

	/* ॢȤå롣*/
	if (tmout == TMO_NBLK) {
		/* Υ֥å󥰥 */
		cep->p_dstaddr    = p_dstaddr;
		cep->p_myaddr     = p_myaddr;
		cep->snd_nblk_tfn = TFN_TCP_CON_CEP;

		/* ͥγߤݥȤ롣*/
		cep->flags |= CEP_FLG_POST_OUTPUT;
		sig_sem(SEM_TCP_POST_OUTPUT);
		return E_WBLK;
		}
	else {

		/*
		 *  p_myaddr  NADR (-1) 
		 *  ݡֹ椬 TCP_PORTANY ʤ顢ưǳƤ롣
		 */
		if ((int)p_myaddr == NADR || p_myaddr->portno == TCP_PORTANY)
			tcp_alloc_auto_port(cep);
		else if ((error = tcp_alloc_port(cep, p_myaddr->portno)) != E_OK)
			goto err_ret;

		/* ͥγߤݥȤ롣*/
		cep->flags |= CEP_FLG_POST_OUTPUT;
		sig_sem(SEM_TCP_POST_OUTPUT);

		/*
		 *  ٥Ȥ ESTABLISHED ˤʤޤԤġ
		 *  ٥Ȥ CLOSED ˤʤäϡ餫Υ顼ȯ
		 *  ³׵᤬ݤ줿Ȥ̣Ƥ롣
		 */
		error = twai_flg(cep->flgid, (CEP_EVT_CLOSED |
		                              CEP_EVT_ESTABLISHED), TWF_ORW, &flag, tmout);
		if (error == E_OK) {
			if (cep->error != E_OK)
				error = cep->error;
			else if (cep->fsm_state == TCP_FSM_CLOSED)
				error = E_CLS;
			}

		syscall(clr_flg(cep->flgid, ~CEP_EVT_ESTABLISHED));

		if (error != E_OK) {
			/*
			 *  ̿üո̿üꥹȤ鳰
			 *  ٥ȥե饰򥯥ꤹ롣
			 */
			cep->rep = NULL;
			cep->fsm_state = TCP_FSM_CLOSED;
			syscall(set_flg(cep->flgid, CEP_EVT_CLOSED));
			}
		}

err_ret:
	cep->snd_tskid = TA_NULL;
	cep->snd_tfn   = TFN_TCP_UNDEF;
	return error;
	}

/*
 *  tcp_sht_cep  -- ǡνλɸൡǽ
 */

ER
tcp_sht_cep (ID cepid)
{
	T_TCP_CCEP	*cep;
	ER		error = E_OK;

	/*
	 *  CEP åAPI ǽɤȥ̻ҤϿ롣
	 *  Ǥ˵ϿƤСڥǥʤΤǥ顼
	 */
	if ((error = tcp_lock_cep(cepid, &cep, TFN_TCP_SHT_CEP)) != E_OK)
		return error;

	/* TCP ̿üΥͥ󤬳Ω֤ǤʤХ顼 */
	if (!TCP_FSM_HAVE_ESTABLISHED(cep->fsm_state)) {
		if ((error = cep->error) == E_OK)
			error = E_OBJ;
		}

	else if ((cep = user_closed(cep)) != NULL) {		/* ͥǤ롣*/

		/* ǥȽϤݥȤ롣*/
		cep->flags |= CEP_FLG_POST_OUTPUT;
		sig_sem(SEM_TCP_POST_OUTPUT);
		}

	cep->snd_tskid = TA_NULL;
	cep->snd_tfn   = TFN_TCP_UNDEF;
	return error;
	}

/*
 *  tcp_cls_cep -- ̿üΥɸൡǽ
 */

ER
tcp_cls_cep (ID cepid, TMO tmout)
{
	T_TCP_CCEP	*cep;
	ER		error = E_OK;
	FLGPTN		flag;

	/*
	 *  CEP åAPI ǽɤȥ̻ҤϿ롣
	 *  Ǥ˵ϿƤСڥǥʤΤǥ顼
	 */
	if ((error = tcp_lock_cep(cepid, &cep, TFN_TCP_CLS_CEP)) != E_OK)
		return error;

	/* ॢȤå롣*/
	if (tmout == TMO_NBLK) {				/* Υ֥å󥰥 */
		if (cep->fsm_state == TCP_FSM_CLOSED) {		/* Ǥ˥ƤȤ */

			cep->rep = NULL;
			if (cep->callback == NULL) {
				syslog(LOG_WARNING, "[tcp_cls_cep] no call back.");
				error = E_OBJ;
				}
			else {
				(*cep->callback)(GET_TCP_CCEPID(cep), TFN_TCP_CLS_CEP, (VP)E_OK);
				error = E_WBLK;
				}
			}
		else {
			/* NBLK API ǽɤꤹ롣*/
			cep->rcv_nblk_tfn = TFN_TCP_CLS_CEP;

			if ((cep = user_closed(cep)) != NULL) {		/* ͥǤ롣*/
				/* ǥȽϤݥȤ롣*/
				cep->flags |= CEP_FLG_POST_OUTPUT;
				sig_sem(SEM_TCP_POST_OUTPUT);
				}

			/*  cep  NULL äƤϡ
			 *  ˥ͥǤƤ뤳Ȥ̣Ƥ롣
			 *  ޤξ祳ХåؿƤӽФƤ롣
			 */
			return E_WBLK;
			}
		}
	else {
		if ((cep = user_closed(cep)) != NULL) {		/* ͥǤ롣*/
			/* ǥȽϤݥȤ롣*/
			cep->flags |= CEP_FLG_POST_OUTPUT;
			sig_sem(SEM_TCP_POST_OUTPUT);

			/* ٥ȥե饰 CLOSED ˤʤޤԤġ*/
			error = twai_flg(cep->flgid, CEP_EVT_CLOSED, TWF_ORW, &flag, tmout);
			if (error == E_OK && cep->error != E_OK)
				error = cep->error;

			if (error != E_OK) {
				if (error == E_RLWAI) {
					/* tcp_cls_cep 󥻥뤵줿ȤϡRST 롣*/
					tcp_respond(NULL, cep, cep->rcv_nxt, cep->snd_una - 1, TCP_FLG_RST, TMO_TCP_OUTPUT);
					}

				/* ޡߤ롣*/
				tcp_cancel_timers(cep);

				/* ȥ塼롣*/
				tcp_free_queue(cep);

				/* ֤̤Ѥˤ롣*/
				cep->fsm_state = TCP_FSM_CLOSED;

				/* ե饰򥯥ꥢ롣*/
				cep->flags = 0;

				cep->rep = NULL;
				syscall(set_flg(cep->flgid, CEP_EVT_CLOSED));
				}
			else
				/* ̿üո̿üꥹȤ鳰*/
				cep->rep = NULL;
			}
		}

	cep->rcv_tskid = TA_NULL;
	cep->rcv_tfn   = TFN_TCP_UNDEF;
	return error;
	}

/*
 *  tcp_snd_dat -- ѥåȤɸൡǽ
 */

ER_UINT
tcp_snd_dat (ID cepid, VP data, INT len, TMO tmout)
{
	T_TCP_CCEP	*cep;
	ER_UINT		error;
	INT		offset;

	/* data  NULL len < 0 ʤ饨顼 */
	if (data == NULL || len < 0)
		return E_PAR;

	/*
	 *  CEP åAPI ǽɤȥ̻ҤϿ롣
	 *  Ǥ˵ϿƤСڥǥʤΤǥ顼
	 */
	if ((error = tcp_lock_cep(cepid, &cep, TFN_TCP_SND_DAT)) != E_OK)
		return error;

	/* ॢȤå롣*/
	if (tmout == TMO_NBLK) {		/* Υ֥å󥰥 */

		/* Ǥ뤫CEP  FSM ֤򸫤롣*/
		if (!TCP_FSM_CAN_SEND_MORE(cep->fsm_state)) {
			if ((error = cep->error) == E_OK)
				error = E_OBJ;

			if (cep->callback == NULL) {
				syslog(LOG_WARNING, "[tcp_snd_dat] no call back.");
				error = E_OBJ;
				}
			else {
				(*cep->callback)(GET_TCP_CCEPID(cep), TFN_TCP_SND_DAT, (VP)error);
				error = E_WBLK;
				}
			goto err_ret;
			}

		/* Хåե˶ХХåؿƤӽФ*/
		if (cep->sbuf_count < cep->sbufsz) {

			/* CEP å롣*/
			syscall(wai_sem(cep->semid_lock));

			/* len Хåեζξܤǡˤ롣*/
			if (len > (cep->sbufsz - cep->sbuf_count))
				len = cep->sbufsz - cep->sbuf_count;

			/* 񤭹ߥݥ󥿤饦ɤȤν */
			if (len > cep->sbufsz - (cep->sbuf_wptr - (UB*)cep->sbuf)) {
				offset = cep->sbufsz - (cep->sbuf_wptr -(UB*)cep->sbuf);
				memcpy(cep->sbuf_wptr, data, offset);
				cep->sbuf_wptr  = (UB*)cep->sbuf;
				cep->sbuf_count += offset;
				}
			else
				offset = 0;

			memcpy(cep->sbuf_wptr, (VP)((UB*)data + offset), len - offset);
			cep->sbuf_wptr  += len - offset;
			cep->sbuf_count += len - offset;

			/* CEP Υå롣*/
			syscall(sig_sem(cep->semid_lock));

			/* ϤݥȤ롣*/
			cep->flags |= CEP_FLG_POST_OUTPUT;
			sig_sem(SEM_TCP_POST_OUTPUT);

			if (cep->callback == NULL) {
				syslog(LOG_WARNING, "[tcp_snd_dat] no call back.");
				error = E_OBJ;
				}
			else {
				(*cep->callback)(GET_TCP_CCEPID(cep), TFN_TCP_SND_DAT, (VP)len);
				error = E_WBLK;
				}
			goto err_ret;
			}
		else {
			cep->snd_data     = data;
			cep->snd_len      = len;
			cep->snd_nblk_tfn = TFN_TCP_SND_DAT;
			return E_WBLK;
			}
		}
	else {

		/* Ǥ뤫CEP  FSM ֤򸫤롣*/
		if (!TCP_FSM_CAN_SEND_MORE(cep->fsm_state)) {
			if ((error = cep->error) == E_OK)
				error = E_OBJ;
			goto err_ret;
			}

		if (cep->sbuf_count >= cep->sbufsz) {
			/*
			 *  ХåեζʤСϤݥȤơ
			 *  ХåեޤԤġ
			 */
			cep->flags |= CEP_FLG_POST_OUTPUT;
			sig_sem(SEM_TCP_POST_OUTPUT);

			while (cep->sbuf_count >= cep->sbufsz) {
				if ((error = twai_sem(cep->semid_sbuf_ready, tmout)) != E_OK)
					goto err_ret;

				/*
				 *  Ǥ뤫CEP  FSM ֤򸫤롣
				 *  ХåեޤԤĴ֤ˡǽˤʤäϡ
				 *  ͥǤ줿Ȥ̣Ƥ롣
				 */
				if (!TCP_FSM_CAN_SEND_MORE(cep->fsm_state)) {
					error = E_CLS;
					goto err_ret;
					}
				}
			}

		/* CEP å롣*/
		syscall(wai_sem(cep->semid_lock));

		/* len Хåեζξܤǡˤ롣*/
		if (len > (cep->sbufsz - cep->sbuf_count))
			len = cep->sbufsz - cep->sbuf_count;
		error = len;

		/* 񤭹ߥݥ󥿤饦ɤȤν */
		if (len > cep->sbufsz - (cep->sbuf_wptr - (UB*)cep->sbuf)) {
			offset = cep->sbufsz - (cep->sbuf_wptr -(UB*)cep->sbuf);
			memcpy(cep->sbuf_wptr, data, offset);
			cep->sbuf_wptr  = (UB*)cep->sbuf;
			cep->sbuf_count += offset;
			}
		else
			offset = 0;

		memcpy(cep->sbuf_wptr, (VP)((UB*)data + offset), len - offset);
		cep->sbuf_wptr  += len - offset;
		cep->sbuf_count += len - offset;

		/* CEP Υå롣*/
		syscall(sig_sem(cep->semid_lock));

		/*
		 *  ǡ롣ХåեեΤȤ϶Ū롣
		 */
		if (cep->sbuf_count >= cep->sbufsz)
			cep->flags |= CEP_FLG_FORCE | CEP_FLG_FORCE_CLEAR;

		/* ϤݥȤ롣*/
		cep->flags |= CEP_FLG_POST_OUTPUT;
		sig_sem(SEM_TCP_POST_OUTPUT);
		}

err_ret:
	cep->snd_tskid = TA_NULL;
	cep->snd_tfn   = TFN_TCP_UNDEF;
	return error;
	}

/*
 *  tcp_get_buf -- ѥХåեγɸൡǽ
 */

ER_UINT
tcp_get_buf (ID cepid, VP *p_buf, TMO tmout)
{
	T_TCP_CCEP	*cep;
	ER_UINT		error;

	/* p_buf  NULL ʤ饨顼 */
	if (p_buf == NULL)
		return E_PAR;

	/*
	 *  CEP åAPI ǽɤȥ̻ҤϿ롣
	 *  Ǥ˵ϿƤСڥǥʤΤǥ顼
	 */
	if ((error = tcp_lock_cep(cepid, &cep, TFN_TCP_GET_BUF)) != E_OK)
		return error;

	/* ॢȤå롣*/
	if (tmout == TMO_NBLK) {		/* Υ֥å󥰥 */

		/* Ǥ뤫CEP  FSM ֤򸫤롣*/
		if (!TCP_FSM_CAN_SEND_MORE(cep->fsm_state)) {
			if ((error = cep->error) == E_OK)
				error = E_OBJ;

			if (cep->callback == NULL) {
				syslog(LOG_WARNING, "[tcp_get_buf] no call back.");
				error = E_OBJ;
				}
			else {
				(*cep->callback)(GET_TCP_CCEPID(cep), TFN_TCP_GET_BUF, (VP)error);
				error = E_WBLK;
				}
			goto err_ret;
			}

		/* Хåե˶ХХåؿƤӽФ*/
		if (cep->sbuf_count < cep->sbufsz) {

			INT	buf_len;

			/* Хåեå롣*/
			syscall(wai_sem(cep->semid_lock));

			/* ХåեĹ׻롣*/
			if (cep->sbufsz - cep->sbuf_count > cep->sbufsz - (cep->sbuf_wptr - (UB*)cep->sbuf))
				/* ߥݥ󥿤饦ɤȤϡߥݥ󥿤Хåեνޤ */
				buf_len = cep->sbufsz - (cep->sbuf_wptr - (UB*)cep->sbuf);
			else
				buf_len = cep->sbufsz - cep->sbuf_count;

			/* tcp_get_buf γĹꤹ롣*/
			cep->get_buf_len = buf_len;

			/* ХåեΥɥ쥹֤*/
			*p_buf = cep->sbuf_wptr;

			/* ХåեΥå롣*/
			syscall(sig_sem(cep->semid_lock));

			if (cep->callback == NULL) {
				syslog(LOG_WARNING, "[tcp_get_buf] no call back.");
				error = E_OBJ;
				}
			else {
				(*cep->callback)(GET_TCP_CCEPID(cep), TFN_TCP_GET_BUF, (VP)buf_len);
				error = E_WBLK;
				}
			goto err_ret;
			}
		else {
			cep->snd_p_buf     = p_buf;
			cep->snd_nblk_tfn = TFN_TCP_GET_BUF;
			return E_WBLK;
			}
		}
	else {

		/* Ǥ뤫CEP  FSM ֤򸫤롣*/
		if (!TCP_FSM_CAN_SEND_MORE(cep->fsm_state)) {
			if ((error = cep->error) == E_OK)
				error = E_OBJ;
			goto err_ret;
			}

		if (cep->sbuf_count >= cep->sbufsz) {
			/*
			 *  ХåեζʤСϤݥȤơ
			 *  ХåեޤԤġ
			 */
			cep->flags |= CEP_FLG_POST_OUTPUT;
			sig_sem(SEM_TCP_POST_OUTPUT);

			while (cep->sbuf_count >= cep->sbufsz) {
				if ((error = twai_sem(cep->semid_sbuf_ready, tmout)) != E_OK)
					goto err_ret;

				/*
				 *  Ǥ뤫CEP  FSM ֤򸫤롣
				 *  ХåեޤԤĴ֤ˡǽˤʤäϡ
				 *  ͥǤ줿Ȥ̣Ƥ롣
				 */
				if (!TCP_FSM_CAN_SEND_MORE(cep->fsm_state)) {
					error = E_CLS;
					goto err_ret;
					}
				}
			}

		/* Хåեå롣*/
		syscall(wai_sem(cep->semid_lock));

		/* ХåեĹ׻롣*/
		if (cep->sbufsz - cep->sbuf_count > cep->sbufsz - (cep->sbuf_wptr - (UB*)cep->sbuf))
			/* ߥݥ󥿤饦ɤȤϡߥݥ󥿤Хåեνޤ */
			error = cep->sbufsz - (cep->sbuf_wptr - (UB*)cep->sbuf);
		else
			error = cep->sbufsz - cep->sbuf_count;

		/* tcp_get_buf γĹꤹ롣*/
		cep->get_buf_len = error;

		/* ХåեΥɥ쥹֤*/
		*p_buf = cep->sbuf_wptr;

		/* ХåեΥå롣*/
		syscall(sig_sem(cep->semid_lock));
		}

err_ret:
	cep->snd_tskid = TA_NULL;
	cep->snd_tfn   = TFN_TCP_UNDEF;
	return error;
	}

/*
 *  tcp_snd_buf -- ХåեΥǡɸൡǽ
 */

ER
tcp_snd_buf (ID cepid, INT len)
{
	T_TCP_CCEP	*cep;
	ER		error;

	/* Ĺ len å롣*/
	if (len < 0)
		return E_PAR;

	/*
	 *  CEP åAPI ǽɤȥ̻ҤϿ롣
	 *  Ǥ˵ϿƤСڥǥʤΤǥ顼
	 */
	if ((error = tcp_lock_cep(cepid, &cep, TFN_TCP_SND_BUF)) != E_OK)
		return error;

	/* Ĺ len å롣*/
	if (len > cep->get_buf_len) {
		error = E_OBJ;
		goto err_ret;
		}

	/* Ǥ뤫CEP  FSM ֤򸫤롣*/
	if (!TCP_FSM_CAN_SEND_MORE(cep->fsm_state)) {
		if ((error = cep->error) == E_OK)
			error = E_OBJ;
		goto err_ret;
		}

	/* CEP å롣*/
	syscall(wai_sem(cep->semid_lock));

	cep->sbuf_wptr  += len;
	cep->sbuf_count += len;

	/* ߥݥ󥿤饦ɤȤν */
	if (cep->sbuf_wptr >= (UB*)cep->sbuf + cep->sbufsz)
		cep->sbuf_wptr  = (UB*)cep->sbuf;

	/* tcp_get_buf γĹꥻåȤ롣*/
	cep->get_buf_len = 0;

	/* CEP Υå롣*/
	syscall(sig_sem(cep->semid_lock));

	/* ХåեեΤȤ϶Ū롣*/
	if (cep->sbuf_count >= cep->sbufsz)
		cep->flags |= CEP_FLG_FORCE | CEP_FLG_FORCE_CLEAR;

	/* ϤݥȤ롣*/
	cep->flags |= CEP_FLG_POST_OUTPUT;
	sig_sem(SEM_TCP_POST_OUTPUT);

err_ret:
	cep->snd_tskid = TA_NULL;
	cep->snd_tfn   = TFN_TCP_UNDEF;
	return error;
	}

/*
 *  tcp_rcv_dat -- ѥåȤμɸൡǽ
 */

ER_UINT
tcp_rcv_dat (ID cepid, VP data, INT len, TMO tmout)
{
	T_TCP_CCEP	*cep;
	ER_UINT		error;
	INT		offset;

	/* data  NULL len < 0 ʤ饨顼 */
	if (data == NULL || len < 0)
		return E_PAR;

	/*
	 *  CEP åAPI ǽɤȥ̻ҤϿ롣
	 *  Ǥ˵ϿƤСڥǥʤΤǥ顼
	 */
	if ((error = tcp_lock_cep(cepid, &cep, TFN_TCP_RCV_DAT)) != E_OK)
		return error;

	/* ॢȤå롣*/
	if (tmout == TMO_NBLK) {		/* Υ֥å󥰥 */

		/*
		 *  Ǥ뤫fsm_state 򸫤롣Ǥʤ
		 *  Ĺ 0 ֤
		 */
		if (!TCP_FSM_CAN_RECV_MORE(cep->fsm_state) &&
		    cep->rbuf_count == 0 && cep->segq == NULL) {
			if (cep->callback == NULL) {
				syslog(LOG_WARNING, "[tcp_rcv_dat] no call back.");
				error = E_OBJ;
				}
			else {
				(*cep->callback)(GET_TCP_CCEPID(cep), TFN_TCP_RCV_DAT, (VP)cep->error);
				error = E_WBLK;
				}

			goto err_ret;
			}

		/* Хåե˥ǡХХåؿƤӽФ*/
		if (cep->rbuf_count > 0) {

			/* CEP å롣*/
			syscall(wai_sem(cep->semid_lock));

			/* len ȼХåեΥǡξܤǡˤ롣*/
			if (len > cep->rbuf_count)
				len = cep->rbuf_count;

			/* ɤ߽Фݥ󥿤饦ɤȤν */
			if (len > cep->rbufsz - (cep->rbuf_rptr - (UB*)cep->rbuf)) {
				offset = cep->rbufsz - (cep->rbuf_rptr -(UB*)cep->rbuf);
				memcpy(data, cep->rbuf_rptr, offset);
				cep->rbuf_rptr   = (UB*)cep->rbuf;
				cep->rbuf_count -= offset;
				}
			else
				offset = 0;

			memcpy((VP)((UB*)data + offset), cep->rbuf_rptr, len - offset);
			cep->rbuf_rptr  += len - offset;
			cep->rbuf_count -= len - offset;

			/* CEP Υå롣*/
			syscall(sig_sem(cep->semid_lock));

			if (cep->callback == NULL) {
				syslog(LOG_WARNING, "[tcp_rcv_dat] no call back.");
				error = E_OBJ;
				}
			else {
				(*cep->callback)(GET_TCP_CCEPID(cep), TFN_TCP_RCV_DAT, (VP)len);
				error = E_WBLK;
				}

			goto err_ret;
			}
		else {
			cep->rcv_data     = data;
			cep->rcv_len      = len;
			cep->rcv_nblk_tfn = TFN_TCP_RCV_DAT;
			return E_WBLK;
			}
		}
	else {

		/*
		 *  Ǥ뤫fsm_state 򸫤롣Ǥʤ
		 *  Ĺ 0ޤϥ顼֤
		 */
		if (!TCP_FSM_CAN_RECV_MORE(cep->fsm_state) &&
		    cep->rbuf_count == 0 && cep->segq == NULL) {
			error = cep->error;
			goto err_ret;
			}

		if (cep->rbuf_count == 0) {
			/* Хåե˥ǡʤСϤޤԤġ*/
			while (cep->rbuf_count == 0) {
				if ((error = twai_sem(cep->semid_rbuf_ready, tmout)) != E_OK)
					goto err_ret;

				/*
				 *  Ǥ뤫fsm_state 򸫤롣Ǥʤ֤ǡ
				 *  ХåեʸʤϽλ롣
				 */
				if (!TCP_FSM_CAN_RECV_MORE(cep->fsm_state) &&
				    cep->rbuf_count == 0 && cep->segq == NULL) {
					error = cep->error;
					goto err_ret;
					}
				}
			}
		else
			twai_sem(cep->semid_rbuf_ready, TMO_POL);

		/* CEP å롣*/
		syscall(wai_sem(cep->semid_lock));

		/* len ȼХåեΥǡξܤǡˤ롣*/
		if (len > cep->rbuf_count)
			len = cep->rbuf_count;
		error = len;

		/* ɤ߽Фݥ󥿤饦ɤȤν */
		if (len > cep->rbufsz - (cep->rbuf_rptr - (UB*)cep->rbuf)) {
			offset = cep->rbufsz - (cep->rbuf_rptr -(UB*)cep->rbuf);
			memcpy(data, cep->rbuf_rptr, offset);
			cep->rbuf_rptr  = (UB*)cep->rbuf;
			cep->rbuf_count -= offset;
			}
		else
			offset = 0;

		memcpy((VP)((UB*)data + offset), cep->rbuf_rptr, len - offset);
		cep->rbuf_rptr  += len - offset;
		cep->rbuf_count -= len - offset;

		/* CEP Υå롣*/
		syscall(sig_sem(cep->semid_lock));

		/* ˥ɥѤäȤΤ餻뤿ϤݥȤ롣*/
		cep->flags |= CEP_FLG_POST_OUTPUT;
		sig_sem(SEM_TCP_POST_OUTPUT);
		}

err_ret:
	cep->rcv_tskid = TA_NULL;
	cep->rcv_tfn   = TFN_TCP_UNDEF;
	return error;
	}

/*
 *  tcp_rcv_buf -- ǡäХåեγɸൡǽ
 */

ER_UINT
tcp_rcv_buf (ID cepid, VP *p_buf, TMO tmout)
{
	T_TCP_CCEP	*cep;
	ER_UINT		error;

	/* p_buf  NULL ʤ饨顼 */
	if (p_buf == NULL)
		return E_PAR;

	/*
	 *  CEP åAPI ǽɤȥ̻ҤϿ롣
	 *  Ǥ˵ϿƤСڥǥʤΤǥ顼
	 */
	if ((error = tcp_lock_cep(cepid, &cep, TFN_TCP_RCV_BUF)) != E_OK)
		return error;

	/* ॢȤå롣*/
	if (tmout == TMO_NBLK) {		/* Υ֥å󥰥 */

		/*
		 *  Ǥ뤫fsm_state 򸫤롣Ǥʤ
		 *  Ĺ 0ޤϥ顼֤
		 */
		if (!TCP_FSM_CAN_RECV_MORE(cep->fsm_state) &&
		    cep->rbuf_count == 0 && cep->segq == NULL) {

			if (cep->callback == NULL) {
				syslog(LOG_WARNING, "[tcp_rcv_buf] no call back.");
				error = E_OBJ;
				}
			else {
				(*cep->callback)(GET_TCP_CCEPID(cep), TFN_TCP_RCV_BUF, (VP)cep->error);
				error = E_WBLK;
				}
			goto err_ret;
			}

		/* Хåե˥ǡХХåؿƤӽФ*/
		if (cep->rbuf_count > 0) {

			/* Хåեå롣*/
			syscall(wai_sem(cep->semid_lock));

			/* ХåեΥǡĹ׻롣*/
			if (cep->rbuf_count > cep->rbufsz - (cep->rbuf_rptr - (UB*)cep->rbuf))
				/* ݥ󥿤饦ɤȤϥХåեνޤ */
				error = cep->rbufsz - (cep->rbuf_rptr - (UB*)cep->rbuf);
			else
				error = cep->rbuf_count;

			/* tcp_rcv_buf γĹꤹ롣*/
			cep->rcv_buf_len = error;
			*p_buf = cep->rbuf_rptr;

			/* ХåեΥå롣*/
			syscall(sig_sem(cep->semid_lock));

			if (cep->callback == NULL) {
				syslog(LOG_WARNING, "[tcp_rcv_buf] no call back.");
				error = E_OBJ;
				}
			else {
				(*cep->callback)(GET_TCP_CCEPID(cep), TFN_TCP_RCV_BUF, (VP)error);
				error = E_WBLK;
				}
			goto err_ret;
			}
		else {
			cep->rcv_p_buf    = p_buf;
			cep->rcv_nblk_tfn = TFN_TCP_RCV_BUF;
			return E_WBLK;
			}
		}
	else {

		/*
		 *  Ǥ뤫fsm_state 򸫤롣Ǥʤ
		 *  Ĺ 0ޤϥ顼֤
		 */
		if (!TCP_FSM_CAN_RECV_MORE(cep->fsm_state) &&
		    cep->rbuf_count == 0 && cep->segq == NULL) {
			error = cep->error;
			goto err_ret;
			}

		if (cep->rbuf_count == 0) {
			/* Хåե˥ǡʤСϤޤԤġ*/
			while (cep->rbuf_count == 0) {
				if ((error = twai_sem(cep->semid_rbuf_ready, tmout)) != E_OK)
					goto err_ret;

				/*
				 *  Ǥ뤫fsm_state 򸫤롣Ǥʤ֤ǡ
				 *  ХåեʸʤϽλ롣
				 */
				if (!TCP_FSM_CAN_RECV_MORE(cep->fsm_state) &&
				    cep->rbuf_count == 0 && cep->segq == NULL) {
					error = cep->error;
					goto err_ret;
					}
				}
			}
		else
			twai_sem(cep->semid_rbuf_ready, TMO_POL);

		/* Хåեå롣*/
		syscall(wai_sem(cep->semid_lock));

		/* ХåեΥǡĹ׻롣*/
		if (cep->rbuf_count > cep->rbufsz - (cep->rbuf_rptr - (UB*)cep->rbuf))
			/* ݥ󥿤饦ɤȤϥХåեνޤ */
			error = cep->rbufsz - (cep->rbuf_rptr - (UB*)cep->rbuf);
		else
			error = cep->rbuf_count;

		/* tcp_rcv_buf γĹꤹ롣*/
		cep->rcv_buf_len = error;
		*p_buf = cep->rbuf_rptr;

		/* ХåեΥå롣*/
		syscall(sig_sem(cep->semid_lock));
		}

err_ret:
	cep->rcv_tskid = TA_NULL;
	cep->rcv_tfn   = TFN_TCP_UNDEF;
	return error;
	}

/*
 *  tcp_rel_buf -- ѥХåեβɸൡǽ
 */

ER
tcp_rel_buf (ID cepid, INT len)
{
	T_TCP_CCEP	*cep;
	ER		error;

	/* Ĺ len å롣*/
	if (len < 0)
		return E_PAR;

	/*
	 *  CEP åAPI ǽɤȥ̻ҤϿ롣
	 *  Ǥ˵ϿƤСڥǥʤΤǥ顼
	 */
	if ((error = tcp_lock_cep(cepid, &cep, TFN_TCP_REL_BUF)) != E_OK)
		return error;

	/* Ĺ len å롣*/
	if (len > cep->rcv_buf_len) {
		error = E_OBJ;
		goto err_ret;
		}

	/* CEP å롣*/
	syscall(wai_sem(cep->semid_lock));

	cep->rbuf_count -= len;
	cep->rbuf_rptr  += len;

	/* ɤ߽Фݥ󥿤饦ɤȤν */
	if (cep->rbuf_rptr >= (UB*)cep->rbuf + cep->rbufsz)
		cep->rbuf_rptr  = (UB*)cep->rbuf;

	/* tcp_rcv_buf γĹꥻåȤ롣*/
	cep->rcv_buf_len = 0;

	/* CEP Υå롣*/
	syscall(sig_sem(cep->semid_lock));

	/* ˥ɥѤäȤΤ餻뤿ϤݥȤ롣*/
	cep->flags |= CEP_FLG_POST_OUTPUT;
	sig_sem(SEM_TCP_POST_OUTPUT);

err_ret:
	cep->rcv_tskid = TA_NULL;
	cep->rcv_tfn   = TFN_TCP_UNDEF;
	return error;
	}

/*
 *  tcp_can_cep -- ڥǥ󥰤ƤΥ󥻥ɸൡǽ
 */

ER
tcp_can_cep (ID cepid, FN fncd)
{
	T_TCP_CCEP	*cep;
	ER		error = E_OK, snd_err, rcv_err;

	/* API ǽɤå롣*/
	if (!VALID_TFN_TCP_CAN(fncd))
		return E_PAR;

	/* TCP ̿üå롣*/
	if (!VALID_TCP_CCEPID(cepid))
		return E_ID;

	/* TCP ̿ü롣*/
	cep = GET_TCP_CCEP(cepid);

	if (fncd == TFN_TCP_ALL) {		/* TFN_TCP_ALL ν */
		snd_err = tcp_can_snd(cep, fncd);
		rcv_err = tcp_can_rcv(cep, fncd);

		/*
		 *  snd_err  rcv_err Τɤ EV_NOPND
		 *  ʤ顢ڥǥ󥰤ƤʤΤǥ顼
		 */
		if (snd_err == EV_NOPND && rcv_err == EV_NOPND)
			error = E_OBJ;
		else {
			if (snd_err == EV_NOPND)
				snd_err = E_OK;
			if (rcv_err == EV_NOPND)
				rcv_err = E_OK;

			if (snd_err != E_OK)
				error = snd_err;
			else if (rcv_err != E_OK)
				error = rcv_err;
			}
		}

	else if (IS_TFN_TCP_RCV(fncd)) {	/* Υ󥻥 */
		if ((error = tcp_can_rcv(cep, fncd)) == EV_NOPND)
			error = E_OBJ;
		}

	else {					/* Υ󥻥 */
		if ((error = tcp_can_snd(cep, fncd)) == EV_NOPND)
			error = E_OBJ;
		}

	return error;
	}
